	subroutine NtupleInit(filename)
	implicit none
	save

	include  'hbook.inc'
	include  'simulate.inc'

	character*80 filename,directory
	character*16 NtupleTag(80),name,title
	integer*4 m,io,recl,bank,id,status
	parameter(recl = 1024)
	parameter(bank = 8000)
	parameter(io = 29)
	parameter(name = 'SimcNtuple')
	parameter(title = 'SIMTUPLE')

	NtupleID = defaultID
	id = NtupleID
	NtupleIO = io
	NtupleName = name

	call HCDIR(directory,'R') !CERNLIB read current directory
	call HROPEN(io,name,filename,'N',recl,status)  !CERNLIB
						!directory set to "//TUPLE"
	if (status.ne.0)then
	  write(6,*) 'HROPEN error: istat=',status
	  stop
	endif

	m = 0
	m = m+1
	NtupleTag(m) = 'hsdelta'	!  1
	m = m+1
	NtupleTag(m) = 'hsyptar'	!  2
	m = m+1
	NtupleTag(m) = 'hsxptar'	!  3
	m = m+1
	NtupleTag(m) = 'hsytar'		!  4
	m = m+1
	NtupleTag(m) = 'hsxfp'		!  5
	m = m+1
	NtupleTag(m) = 'hsxpfp'		!  6
	m = m+1
	NtupleTag(m) = 'hsyfp'		!  7
	m = m+1
	NtupleTag(m) = 'hsypfp'		!  8
	m = m+1
	NtupleTag(m) = 'hsdeltai'	!  9
	m = m+1
	NtupleTag(m) = 'hsyptari'	! 10
	m = m+1
	NtupleTag(m) = 'hsxptari'	! 11
	m = m+1
	NtupleTag(m) = 'hsytari'	! 12
	m = m+1
	NtupleTag(m) = 'ssdelta'	! 13
	m = m+1
	NtupleTag(m) = 'ssyptar'	! 14
	m = m+1
	NtupleTag(m) = 'ssxptar'	! 15
	m = m+1
	NtupleTag(m) = 'ssytar'		! 16
	m = m+1
	NtupleTag(m) = 'ssxfp'		! 17
	m = m+1
	NtupleTag(m) = 'ssxpfp'		! 18
	m = m+1
	NtupleTag(m) = 'ssyfp'		! 19
	m = m+1
	NtupleTag(m) = 'ssypfp'		! 20
	m = m+1
	NtupleTag(m) = 'ssdeltai'	! 21
	m = m+1
	NtupleTag(m) = 'ssyptari'	! 22
	m = m+1
	NtupleTag(m) = 'ssxptari'	! 23
	m = m+1
	NtupleTag(m) = 'ssytari'	! 24
	m = m+1
	NtupleTag(m) = 'q'		! 25
	m = m+1
	NtupleTag(m) = 'omega'		! 26
	m = m+1
	NtupleTag(m) = 'Q2'		! 27
	m = m+1
	NtupleTag(m) = 'W'		! 28
	m = m+1
	NtupleTag(m) = 'epsilon'	! 29
	m = m+1
	NtupleTag(m) = 'Em'		! 30
	m = m+1
	NtupleTag(m) = 'Pm'		! 31
	m = m+1
	NtupleTag(m) = 'thetapq'	! 32
	m = m+1
	NtupleTag(m) = 'phipq'		! 33
	m = m+1
	NtupleTag(m) = 'th_tarq'	! 34
	m = m+1
	NtupleTag(m) = 'phitarq'	! 35
	m = m+1
	NtupleTag(m) = 'thetapqi'	! 36
	m = m+1
	NtupleTag(m) = 'phipqi'		! 37
	m = m+1
	NtupleTag(m) = 'th_tarqi'	! 38
	m = m+1
	NtupleTag(m) = 'phitarqi'		! 39

	if (doing_pion .or. doing_kaon .or. doing_dvcs) then
	  m = m+1
	  NtupleTag(m) = 'missmass'	! 40
	  m = m+1
	  NtupleTag(m) = 'mmnuc'	! 41
	  m = m+1
	  NtupleTag(m) = 'ppi'		! 42
	  m = m+1
	  NtupleTag(m) = 't'		! 43
	  m = m+1
	  NtupleTag(m) = 'fry'		! 44		!+y is up.
	  m = m+1
	  NtupleTag(m) = 'radphot'	! 45
	  m = m+1
	  NtupleTag(m) = 'pdotqhat'	! 46
	  m = m+1
	  NtupleTag(m) = 'siglab'	! 47
	  m = m+1
	  NtupleTag(m) = 'siglabjv'	! 48
	  m = m+1
	  NtupleTag(m) = 'Weight'	! 49
	  m = m+1
	  NtupleTag(m) = 'jacobian'	! 50
	  m = m+1
	  NtupleTag(m) = 'decdist'	! 51
	  m = m+1
	  NtupleTag(m) = 'Mhadron'	! 52
	  m = m+1
	  NtupleTag(m) = 'pfer'	! 53
	  m = m+1
	  NtupleTag(m) = 'pmpar'	! 54
	  m = m+1
	  NtupleTag(m) = 'pmper'	! 55
	  m = m+1
	  NtupleTag(m) = 'pmoop'	! 56
	  m = m+1
	  NtupleTag(m) = 'betai'	! 57
	  m = m+1
	  NtupleTag(m) = 'beta' 	! 58
	  m = m+1
	  NtupleTag(m) = 'phisiv' 	! 59
	  m = m+1
	  NtupleTag(m) = 'phicol' 	! 60 
	  m = m+1
	  NtupleTag(m) = 'sigl' 	! 61
	  m = m+1
	  NtupleTag(m) = 'sigt' 	! 62
	  m = m+1
	  NtupleTag(m) = 'eprime' 	! 63
	  m = m+1
	  NtupleTag(m) = 'z'    	! 64

	  else if (doing_semi.or.doing_rho) then
	  m = m+1
	  NtupleTag(m) = 'missmass'	! 40
	  m = m+1
	  NtupleTag(m) = 'ppi'		! 41
	  m = m+1
	  NtupleTag(m) = 't'		! 42
	  m = m+1
	  NtupleTag(m) = 'fry'		! 43		!+y is up.
	  m = m+1
	  NtupleTag(m) = 'radphot'	! 44
	  m = m+1
	  NtupleTag(m) = 'siglab'	! 45
	  m = m+1
	  NtupleTag(m) = 'Weight'	! 46
	  m = m+1
	  NtupleTag(m) = 'decdist'	! 47
	  m = m+1
	  NtupleTag(m) = 'Mhadron'	! 48
	  m = m+1
	  NtupleTag(m) = 'betai'	! 49
	  m = m+1
	  NtupleTag(m) = 'beta' 	! 50
	  m = m+1
	  NtupleTag(m) = 'phisivi' 	! 51
	  m = m+1
	  NtupleTag(m) = 'phisiv' 	! 52
	  m = m+1
	  NtupleTag(m) = 'phicoli' 	! 53 
	  m = m+1
	  NtupleTag(m) = 'phicol' 	! 54 
	  m = m+1
	  NtupleTag(m) = 'z' 	        ! 55
	  m = m+1
	  NtupleTag(m) = 'pt2' 	        ! 56
	  m = m+1
	  NtupleTag(m) = 'thqi' 	! 57	  
	  m = m+1
	  NtupleTag(m) = 'sighad' 	! 58	  
	  m = m+1
	  NtupleTag(m) = 'jacobian' 	! 59	  
	  m = m+1
	  NtupleTag(m) = 'dilution' 	! 60	  
	  m = m+1
	  NtupleTag(m) = 'eprime' 	! 61	  
	  if(doing_rho) then
	     m = m+1
	     NtupleTag(m) = 'Mrho'      ! 61
	     m = m+1
	     NtupleTag(m) = 'Thrho'     ! 62
	  endif
	else if (doing_hyd_elast .or. doing_deuterium .or. doing_heavy) then
	  m = m+1
	  NtupleTag(m) = 'corrsing'	! 34
	  m = m+1
	  NtupleTag(m) = 'Pmx'		! 35		!for Heepcheck
	  m = m+1
	  NtupleTag(m) = 'Pmy'		! 36		!for Heepcheck
	  m = m+1
	  NtupleTag(m) = 'Pmz'		! 37		!for Heepcheck
	  m = m+1
	  NtupleTag(m) = 'PmPar'	! 38
	  m = m+1
	  NtupleTag(m) = 'PmPer'	! 39
	  m = m+1
	  NtupleTag(m) = 'PmOop'	! 40
	  m = m+1
	  NtupleTag(m) = 'fry'		! 41		!+y is up.
	  m = m+1
	  NtupleTag(m) = 'radphot'	! 42
	  m = m+1
	  NtupleTag(m) = 'sigcc'	! 43
	  m = m+1
	  NtupleTag(m) = 'Weight'	! 44
	endif

!	else		!used to be the if (doing_phsp) option.
!	 m=m+1
!	 NtupleTag(m)='gd'
!	 m=m+1
!	 NtupleTag(m)='gt'
!	 m=m+1
!	 NtupleTag(m)='gp'
!	 m=m+1
!	 NtupleTag(m)='gy'
!	 m=m+1
!	 NtupleTag(m)='rd'
!	 m=m+1
!	 NtupleTag(m)='rt'
!	 m=m+1
!	 NtupleTag(m)='rp'
!	 m=m+1
!	 NtupleTag(m)='ry'
!	 m=m+1
!	 NtupleTag(m)='w'
!	endif

	NtupleSize = m

	call HBOOKN(id,title,NtupleSize,name,bank,NtupleTag) !create Ntuple

	call HCDIR(NtupleDirectory,'R') !record Ntuple directory

	call HCDIR(directory,' ')       !reset CERNLIB directory

	return
	end
