	real*8 function peeK(vertex,main,survivalprob)

*
* Purpose:
* This routine calculates N(e,e'K)Y cross sections.
*
* variables:
*
*   output:
*	peeK	!d3sigma/(dE_e'*dOmega_e'*Omega_K) - fm^2/MeV/sr^2
*
	implicit none
	include 'simulate.inc'

	record /event_main/ main
	record /event/	vertex

	real*8 MPG,EF_P_I,EF_E_I,T,S,SG,qmu2_g,phi
	real*8 sigma_eek
	real*8 epsi,tcos
	real*8 gtpr
	real*8 bstar,gstar
	real*8 jac,tsin,tssin,tscos,pstar
	real*8 tfcos,tfsin,angl,theta
!	real*8 spath,spatha,spathb
	real*8 pathlen,zaero,betak,gammak
	real*8 survivalprob
	integer*4 ichoice

* Initialize some variables (eekeek.f wants GeV, plus we need some angles,
* jacobians, etc...)

	Mpg  = Mp/1.d3

	tcos = vertex.up.x*vertex.uq.x+vertex.up.y*vertex.uq.y+vertex.up.z*vertex.uq.z
	tfcos = pferx*vertex.uq.x+pfery*vertex.uq.y+pferz*vertex.uq.z
	if(tcos-1..gt.0..and.tcos-1..lt.1.d-8)tcos=1.0 
	if(tfcos-1..gt.0..and.tfcos-1..lt.1.d-8)tfcos=1.0 
	epsi = 1./(1.+2*(1.+vertex.omega**2/vertex.Q2)*tan(vertex.e.theta/2.)**2)
	tsin = sqrt(1.-tcos**2)
	tfsin = sqrt(1.-tfcos**2)
	ef_p_i = sqrt(vertex.p.P**2 + Mh2)

	t = vertex.Q2-Mh2+2.*vertex.omega*ef_p_i-2.*vertex.p.P*vertex.q*tcos
 	t = -1.*t/1.d6				!convert to (GeV/c)**2

	bstar = sqrt((vertex.q+pfer*tfcos)**2+(pfer*tfsin)**2)
     &		/(sqrt(Mp2+pfer**2)+vertex.omega)
	gstar = 1./sqrt(1.-bstar**2)
	pstar = sqrt((vertex.p.P*tsin)**2+(gstar*vertex.p.P*tcos-
     &		gstar*bstar*vertex.p.E)**2)
	tssin = vertex.p.P/pstar*tsin
	tscos = sqrt(1.-tssin**2)
	jac = 1./((tsin/tssin)**2*(tcos*tscos+gstar*tsin*tssin))

	qmu2_g = -1.*vertex.Q2/1.d6
 	ef_e_i = sqrt(vertex.e.P**2 + Me2)
	s = (vertex.omega+sqrt(Mp2+pfer**2))**2
     &		-(vertex.q+pfer*tfcos)**2-(pfer*tfsin)**2
 	sg = s/1.d6				!CONVERT TO (GeV)**2

	angl = dacos(tscos)
	theta = dacos(tcos)

	if (targ.Mrec_struck.lt.1150.) then	!lambda production.
	  ichoice=1
	  call eekeek(sg,qmu2_g,angl,theta,phi,epsi,sigma_eek)
	else
	  ichoice=2				!sigma production.
	  call eekeeks(sg,qmu2_g,angl,theta,phi,epsi,sigma_eek)
	endif
	ntup.sigcm = sigma_eek		!IS THIS THE CM CROSS SECTION???
	qmu2_g = -1.*qmu2_g

* Virtual photon to electron beam flux conversion factor

	gtpr = alpha/2./(pi**2)*ef_e_i/vertex.Ein*(sg-mpg**2)/2./mpg/qmu2_g/(1.-epsi)

!* ONLY WORKS FOR SOS. NEED PATHLENGTH MES FROM SINGLE ARM MONTECARLOS.
!	spatha = 2.923*main.FP.p.dx - 6.1065*main.FP.p.dx**2
!     &		+0.006908*main.FP.p.x*main.FP.p.dx + 0.001225*main.FP.p.x
!     &		-0.0000324*main.FP.p.x**2 -21.936*main.FP.p.dy**2
!	spatha = spatha*-29.9792458
!	if(debug(5).eq.1)write(6,*) 'spatha',spatha/100.,main.FP.p.x
!	spathb = 253.81*sqrt(1.+main.FP.p.dx**2+main.FP.p.dy**2)
!	if(debug(5).eq.1)write(6,*) 'spathb',spathb/100.-2.5381
!	spath = ((spatha+spathb)/100.+7.2637)/3.709
!	betak = vertex.p.P/sqrt(vertex.p.P**2+Mh2)
!	gammak = 1./sqrt(1.-betak**2)
!	pgamcm = spath/betak/gammak
!
!c based on front of aerogel, position 2.5381 m from Rick+Chris,
!c 7.2637 from target to focal plane from DHP,3.709 decay time in meters
!c can also use 7.1944 from Jin RF
!cc	pgamcm = 2.4811/betak/gammak
!	if(debug(5).eq.1)write(6,*) 'spathi',spath,betak,vertex.p.delta
!	a = exp(pgamcm)

c If doing_decay=.false., generate survival probability for main.weight.
c main.FP.p.path is dist. to back of detector, want decay prob. at aerogel.

	survivalprob = 1.
	if (.not.doing_decay) then
	  if (hadron_arm.eq.1) then
	    zaero = 0.			!no aerogel yet, use full length.
	  else if (hadron_arm.eq.2) then
	    zaero = -126.		!aero at 220cm,last project=346(cal).
	  else if (hadron_arm.eq.3) then
	    zaero = -183.		!aero at 130cm,last project=313(S2)
	  else if (hadron_arm.eq.4) then
	    zaero = -183.
	  endif
	  pathlen = main.FP.p.path + zaero*(1+main.FP.p.dx**2+main.FP.p.dy**2)
	  betak = vertex.p.P/sqrt(vertex.p.P**2+Mh2)
	  gammak = 1./sqrt(1.-betak**2)
	  survivalprob = 1./exp(pathlen/(ctau*betak*gammak))
	  decdist=survivalprob		!decdist in ntuple
	endif

	if(debug(5).eq.1)write(6,*) 'sigmao',sigma_eek
	sigma_eek = sigma_eek*gtpr*jac
	if(debug(5).eq.1)write(6,*) 'sigma',gtpr,jac
*
* for deuterium, multiply by (P_p*P_q/(E_n*E_q))
*   = E_p/E_n - Beta_n*tfcos
*
* WHAT ABOUT KAONS?????  DO WE WANT THIS??????
*
	if (doing_deutpi) sigma_eek=sigma_eek*(1.-pfer/sqrt(pfer**2+Mn2)*tfcos)
	if (debug(5).eq.1)write(6,*) 'sigma1',sigma_eek

* UNITS?????
	peeK = sigma_eek
	return
	end




	real*8 function peepi(vertex,main)

* Purpose:
* This routine calculates p(e,e'pi+)n cross sections from a fit to the data of
* Brauel et al., Z.Phys.C. 3(1979)101.
*
* variables:
*   input:
*	omega		!energy of virtual photon		(MeV)
*	theta_pq	!angle between pi and q			(rad)
*	Q2_g            !4-momentum of virtual photon, squared  (GeV/c)^2
*	epsilon		!epsilon				(dimensionless)
*
*   output:
*	sigma_eepi	!d3sigma/dEe'dOmegae'Omegapi	(microbarn/MeV/sr^2)

	implicit none
	include 'simulate.inc'

	record /event_main/ main
	record /event/	vertex

* NOTE: when we refer to the center of mass system, it always refers to the
* photon-NUCLEON center of mass, not the photon-NUCLEUS!  The model gives
* the cross section in the photon-nucleon center of mass frame.

	real*8 sigma_eepi		!final cross section (returned as peepi)
c	real*8 mrho
	real*8 fpi,fpi2			!pion form factor (squared).
	real*8 sig219,sig,factor
	real*8 sigt,sigl,siglt,sigtt	!components of dsigma/dt
	real*8 s5lab			!dsigma/dE_e/dOmega_e/dOmega_pi (in some lab)
c	real*8 efer			!energy of target particle
	real*8 epsi			!epsilon of virtual photon
	real*8 gtpr			!gamma_t prime.
	real*8 tcos,tsin		!cos/sin of theta between ppi and q
	real*8 tfcos,tfsin		!cos/sin of theta between pfermi and q
	real*8 bstar,bstarx,bstary,bstarz,gstar	!beta/gamma of C.M. system in lab
	real*8 ppix,ppiy,ppiz		!pion momentum in lab.
	real*8 thetacm,phicm		!C.M. scattering angles
	real*8 costcm,costo2cm
	real*8 sintcm,sinto2cm
	real*8 ppicm,ppicmx,ppicmy,ppicmz,epicm	 !pion E,p in C.M.
	real*8 qstar,qstarx,qstary,qstarz,nustar !c.m. photon momentum/energy
	real*8 zero

	real*8 s,t,Q2_g			!t,s, Q2 in (GeV/c)**2
	real*8 nu			!equivilent photon energy (MeV)

	real*8 root_two,mpi_to_microbarn
	real*8 CLEB(2,3),qfm,Q2_table(8),nu_table(10),atemp(42)
	real*8 Q2_high,Q2_low,deltaQ2,nu_high,nu_low,delta_nu,F
	real*8 new_x_x,new_x_y,new_x_z
	real*8 new_y_x,new_y_y,new_y_z
	real*8 new_z_x,new_z_y,new_z_z
	real*8 dummy,p_new_x,p_new_y,phiqn
	real*8 davesig,phipq,cospq,sinpq
	real*8 square_root,dp_dcos_num,dp_dcos_den,dp_dcos
	real*8 dp_dphi_num,dp_dphi_den,dp_dphi
	real*8 dt_dcos_lab,dt_dphi_lab,psign
	real*8 dpxdphi,dpydphi,dpxdcos,dpydcos,dpzdcos,dpzdphi
	real*8 dpxnewdphi,dpynewdphi,dpxnewdcos,dpynewdcos
	real*8 dpznewdphi,dpznewdcos
	real*8 dphicmdphi,dphicmdcos
	real*8 jacobian

	real*8 pbeam,beam_newx,beam_newy,beam_newz
	real*8 pbeamcmx,pbeamcmy,pbeamcmz,ebeamcm,pbeamcm
	real*8 ppicm_newx,ppicm_newy,ppicm_newz

	real*8 dEcmdcos,dEcmdphi,dcoscmdcos,dcoscmdphi
	real*8 qx,qy,qz,px,py,pz

	complex*8 H1,H2,H3,H4,H5,H6         !Helicity amplitudes
	complex*8 amplitude(7),A1,A2,A3,A4,A12,A34,A1234
	complex*8 AT(7,3,8,10)
	complex*8 gf1,gf2,gf3,gf4,gf7,gf8
	complex*8 hnperp,hfperp,hnpar,hfpar,hnlong,hflong
	complex*8 XL,XT,XTT,XLT

	integer Q2_count,nu_count,multipole,IT1,IT2,IT3,IT4,IT5
	integer final_state,isospin

	logical first,low_w_flag

	integer t_count,itab,j

	real*8 Q2_tab(8),t_tab(130),stab(8,130,4),sinterp(4)
	real*8 t_high,t_low,delta_t,Q2_tmp,t_tmp,wfactor

	character*33 filename(8)
c	character*26 filename(8)

c	data filename /'regge/regge_q22p0_w2p1.dat',
c	1    'regge/regge_q22p5_w2p1.dat',
c	2    'regge/regge_q23p0_w2p1.dat',
c	3    'regge/regge_q23p5_w2p1.dat',
c	4    'regge/regge_q24p0_w2p1.dat',
c	5    'regge/regge_q24p5_w2p1.dat',
c	6    'regge/regge_q25p0_w2p1.dat',
c	7    'regge/regge_q25p5_w2p1.dat'/

	data filename /'regge/regge_q22p0_w2p0_rho1.5.dat',
	1    'regge/regge_q22p5_w2p0_rho1.5.dat',
	2    'regge/regge_q23p0_w2p0_rho1.5.dat',
	3    'regge/regge_q23p5_w2p0_rho1.5.dat',
	4    'regge/regge_q24p0_w2p0_rho1.5.dat',
	5    'regge/regge_q24p5_w2p0_rho1.5.dat',
	6    'regge/regge_q25p0_w2p0_rho1.5.dat',
	7    'regge/regge_q25p5_w2p0_rho1.5.dat'/

	data first /.TRUE./
	data low_w_flag /.FALSE./   !Assume high W kinematics to start

* Initialize some stuff.
	Q2_g = vertex.Q2/1000000.
	phipq = main.phi_pq
	cospq = cos(phipq)
	sinpq = sin(phipq)
	if(which_pion.eq.0 .or. which_pion.eq.10) then	!pi+
	  final_state = 1
	else
	  final_state = 2
	endif

* calculate energy of initial (struck) nucleon, using the same assumptions that
* go into calculating the pion angle/momentum (in event.f).  For A>1, the struck
* nucleon is off shell, the 2nd nucleon (always a neutron) is on shell, and has
* p = -p_fermi, and any additional nucleons are at rest.

	efer = sqrt(pfer**2+targ.Mtar_struck**2)
	if(doing_deutpi.or.doing_hepi) then
	  efer = targ.M-sqrt(Mn2+pfer**2)
          if(doing_hepi) then
             efer = sqrt(pfer**2 + (targ.Mtar_struck - vertex.Em)**2)
          endif
c	  mtar_offshell = sqrt(efer**2-pfer**2)
	endif


* calculate some kinematical variables
* f's and fer indicate fermi momenta, s, star or cm CM system

	tcos = vertex.up.x*vertex.uq.x+vertex.up.y*vertex.uq.y+vertex.up.z*vertex.uq.z
	if(tcos-1..gt.0..and.tcos-1..lt.1.d-8)tcos=1.0
	tsin=sqrt(1.-tcos**2)

	tfcos = pferx*vertex.uq.x+pfery*vertex.uq.y+pferz*vertex.uq.z
	if(tfcos-1..gt.0..and.tfcos-1..lt.1.d-8)tfcos=1.0
	tfsin=sqrt(1.-tfcos**2)

	epsi = 1./(1.+2*(1.+vertex.omega**2/vertex.Q2)*tan(vertex.e.theta/2.)**2)

	s = (vertex.omega+efer)**2-(vertex.q+pfer*tfcos)**2-(pfer*tfsin)**2
	nu = (s-(efer**2-pfer**2))/2./(efer-pfer*tfcos) !equiv pho energy(MeV)
c	if((nu.lt.500.).and.(first))then
c	  write(6,*) 'Using low W multipole pion model...'
c	  low_w_flag = .TRUE.
c	endif
	s = s/1.d6				!CONVERT TO (GeV)**2
	main.w = sqrt(s)

	t = vertex.Q2-Mh2+2.*vertex.omega*vertex.p.E-2.*vertex.p.P*vertex.q*tcos
	t = t/1.d6				!CONVERT TO (GeV/c)**2
	main.t = t

* Calculate velocity of PHOTON-NUCLEON C.M. system in the lab frame. Use beta
* and gamma of the cm system (bstar and gstar) to transform particles into
* c.m. frame.  Define z along the direction of q, and x to be along the
* direction of the pion momentum perpendicular to q.
* DJG: Get pfer components in the lab "q" system

* JRA:The transformation is calculated starting in the coord. system used
* in the fpi/nucpi replay (see event.f), where x=right, y=down, z=along beam.
* We must convert from SIMC coords to these first.
	qx = -vertex.uq.y           !'right'
	qy =  vertex.uq.x           !'down'
	qz =  vertex.uq.z
	px = -pfery
	py =  pferx
	pz =  pferz

	dummy=sqrt((qx**2+qy**2)*(qx**2+qy**2+qz**2))
	new_x_x = -qx*qz/dummy
	new_x_y = -qy*qz/dummy
	new_x_z = (qx**2 + qy**2)/dummy

	dummy   = sqrt(qx**2 + qy**2)
	new_y_x =  qy/dummy
	new_y_y = -qx/dummy
	new_y_z =  0.0

	p_new_x = pfer*(px*new_x_x + py*new_x_y + pz*new_x_z)
	p_new_y = pfer*(px*new_y_x + py*new_y_y + pz*new_y_z)

	if(p_new_x.eq.0.)then
	  phiqn=0.
	else
	  phiqn = atan2(p_new_y,p_new_x)
	endif
	if(phiqn.lt.0.)phiqn = phiqn+2.*pi

* get beam in "q" system.

	pbeam = sqrt(vertex.Ein**2-me**2)
	beam_newx = pbeam*new_x_z
	beam_newy = pbeam*new_y_z
	beam_newz = pbeam*vertex.uq.z

	bstar=sqrt((vertex.q+pfer*tfcos)**2+(pfer*tfsin)**2)/(efer+vertex.omega)
	gstar=1./sqrt(1. - bstar**2)

	bstarz = (vertex.q+pfer*tfcos)/(efer+vertex.omega)
	bstarx = p_new_x/(efer+vertex.omega)
	bstary = p_new_y/(efer+vertex.omega)

* DJG: Boost virtual photon to CM.

	zero =0.d0
	call loren(gstar,bstarx,bstary,bstarz,vertex.omega,
     >		zero,zero,vertex.q,nustar,qstarx,qstary,qstarz,qstar)

* DJG: Boost pion to CM.
	
	ppiz = vertex.p.P*tcos
	ppix = vertex.p.P*tsin*cospq
	ppiy = vertex.p.P*tsin*sinpq
	call loren(gstar,bstarx,bstary,bstarz,vertex.p.E,
     >		ppix,ppiy,ppiz,epicm,ppicmx,ppicmy,ppicmz,ppicm)
	thetacm = acos((ppicmx*qstarx+ppicmy*qstary+ppicmz*qstarz)/ppicm/qstar)
	main.pcm = ppicm

* DJG Boost the beam to CM.

	call loren(gstar,bstarx,bstary,bstarz,vertex.Ein,beam_newx,
     >		beam_newy,beam_newz,ebeamcm,pbeamcmx,pbeamcmy,pbeamcmz,pbeamcm)

* Thetacm is defined as angle between ppicm and qstar.
* To get phicm, we need out of plane angle relative to scattering plane
* (plane defined by pbeamcm and qcm).  For stationary target, this plane
* does not change.  In general, the new coordinate system is defined such
* that the new y direction is given by (qcm x pbeamcm) and the new x
* is given by (qcm x pbeamcm) x qcm.

	dummy = sqrt((qstary*pbeamcmz-qstarz*pbeamcmy)**2+
     >		(qstarz*pbeamcmx-qstarx*pbeamcmz)**2
     >		+(qstarx*pbeamcmy-qstary*pbeamcmx)**2)
	new_y_x = (qstary*pbeamcmz-qstarz*pbeamcmy)/dummy
	new_y_y = (qstarz*pbeamcmx-qstarx*pbeamcmz)/dummy
	new_y_z = (qstarx*pbeamcmy-qstary*pbeamcmx)/dummy

	dummy = sqrt((new_y_y*qstarz-new_y_z*qstary)**2
     >		+(new_y_z*qstarx-new_y_x*qstarz)**2
     >		+(new_y_x*qstary-new_y_y*qstarx)**2)
	new_x_x = (new_y_y*qstarz-new_y_z*qstary)/dummy
	new_x_y = (new_y_z*qstarx-new_y_x*qstarz)/dummy
	new_x_z = (new_y_x*qstary-new_y_y*qstarx)/dummy

	new_z_x = qstarx/qstar
	new_z_y = qstary/qstar
	new_z_z = qstarz/qstar

	ppicm_newx = ppicmx*new_x_x + ppicmy*new_x_y + ppicmz*new_x_z
	ppicm_newy = ppicmx*new_y_x + ppicmy*new_y_y + ppicmz*new_y_z
	ppicm_newz = ppicmx*new_z_x + ppicmy*new_z_y + ppicmz*new_z_z

	sintcm = sin(thetacm)
	costcm = cos(thetacm)
	sinto2cm = sin(thetacm/2.)
	costo2cm = cos(thetacm/2.)
	phicm = atan2(ppicm_newy,ppicm_newx)
	if(phicm.lt.0.) phicm = 2.*3.141592654+phicm

	main.thetacm = thetacm
	main.phicm = phicm

*******************************************************************************
c	if((nu.ge.500.0).and.(low_w_flag)) then
c	  WRITE(6,*) 'LOOK OUT CHEESY POOF BREATH!'
c	  WRITE(6,*) 'W IS TOO HIGH FOR THIS MODEL'
c	  WRITE(6,*) 'SETTING NU to 499.9'
c	nu=499.9
c	endif

	if(low_w_flag) then     !Use multipole expansion for low W.

* DJG Initialize CG Coefficients for low W model.
*       Clebsch-Gordon Coefficients  CLEB(FINAL STATE, ISOSPIN)
*					  1: PI+ N--------1(IS.1/2)
*					  2: PI- P--------2(IV.1/2)
*						  --------3(IV.3/2)
	  root_two = sqrt(2.)
	  mpi_to_microbarn = 197.327/mh
	  CLEB(1,1)=root_two
	  CLEB(1,2)=root_two/3.
	  CLEB(1,3)=-root_two/3.
	
	  CLEB(2,1)=root_two
	  CLEB(2,2)=-root_two/3.
	  CLEB(2,3)=root_two/3.

* DJG Read in multipoles for low W model.

	  if(first) then
	    first = .FALSE.
	    OPEN(3,FILE='MULTIPOL.file',STATUS='OLD')
	    do Q2_count = 1,8
	      read(3,202) qfm				!q**2 in fm**-2
	      Q2_table(Q2_count) = qfm*0.0389379	!convert to GeV**2
	      do nu_count=1,10
		read(3,203)nu_table(nu_count)
		read(3,204)atemp	!multipolarity amplitudes, see,eg,table below
		do multipole=1,7
		  IT1=multipole+7
		  IT2=multipole+14
		  IT3=multipole+21
		  IT4=multipole+28
		  IT5=multipole+35

C      Multipoles in units of  10**-2 MPI+**-1
C  Multipole Amplitude Table: AT(TYPE    ,  ISOSPIN ,-Q**2 , P.EQ.PH.R.)
C				  1:-----E0+-------0(IS.1/2)
C				  2:-----M1--------1(IV.1/2)
C				  3:-----E1+-------3(IV.3/2)
C				  4:-----M1+
C				  5:-----S0+
C				  6:-----S1-
C				  7:-----S1+
		  AT(multipole,3,Q2_count,nu_count)=
     >			CMPLX(ATEMP(multipole),ATEMP(IT1))
		  AT(multipole,2,Q2_count,nu_count)=CMPLX(ATEMP(IT2),ATEMP(IT3))
		  AT(multipole,1,Q2_count,nu_count)=CMPLX(ATEMP(IT4),ATEMP(IT5))
		enddo	!multipole
	      enddo	!nu
	    enddo	!Q2
	    close(unit=3)
	  endif		!if first time.

* Interpolate multipole amplitudes from table.
	  do Q2_count=1,8
	    Q2_high=0.
	    Q2_low=0.
	    nu_high=0.
	    nu_low=0.
	    if((Q2_g.gt.Q2_table(Q2_count)).and.
     >	       (Q2_g.lt.Q2_table(Q2_count+1))) then
	      Q2_high = Q2_table(Q2_count+1)
	      Q2_low = Q2_table(Q2_count)
	      deltaQ2 = (Q2_high-Q2_low)
	      do nu_count=1,10
		if((nu.gt.nu_table(nu_count)).and.
     >		   (nu.lt.nu_table(nu_count+1))) then
		  nu_high = nu_table(nu_count+1)
		  nu_low =  nu_table(nu_count)
		  delta_nu = nu_high-nu_low
		  do multipole=1,7
		  amplitude(multipole) = 0.
		    do isospin = 1,3
		      A1 = AT(multipole,isospin,Q2_count,nu_count)
		      A2 = AT(multipole,isospin,Q2_count+1,nu_count)
		      A3 = AT(multipole,isospin,Q2_count,nu_count+1)
		      A4 = AT(multipole,isospin,Q2_count+1,nu_count+1)
		      A12= (A1*(Q2_high-Q2_g) + A2*(Q2_g-Q2_low))/deltaQ2
		      A34= (A3*(Q2_high-Q2_g) + A4*(Q2_g-Q2_low))/deltaQ2
		      A1234 = (A12*(nu_high-nu)+A34*(nu-nu_low))/delta_nu
		      amplitude(multipole) = amplitude(multipole) +
     >					CLEB(final_state,isospin)*A1234
		   enddo
*					!Convert multipoles to microb^.5
		   amplitude(multipole) = mpi_to_microbarn*amplitude(multipole)
		  enddo
		endif	!nu check
	      enddo	!nu
	    endif	!Q2 check
	  enddo		!Q2

* Now calculate the Helicity amplitudes

* CGLN amplitudes (Chew et. al.,Phys. Rev. 106,1345 (1957).)

	  gf1 = amplitude(1) + 3.*costcm*(amplitude(4)+amplitude(3))
	  gf2 = 2.*amplitude(4) + amplitude(2)
	  gf3 = 3.*(amplitude(3)-amplitude(4))
	  gf4 = (0.,0.)
* DJG: gf5 and gf6 are not independent of gf7 and gf8,so only use last two.
	  gf7 = amplitude(6) - 2.*amplitude(7)
	  gf8 = amplitude(5) + 6.*costcm*amplitude(7)

* DJG WALKER helicity amplitudes (Walker,Phys.Rev. 182,1729 (1969).)
	  H5 = -costo2cm*(gf7+gf8)
	  H6 = -sinto2cm*(gf7-gf8)
	  H4 = (2.*sinto2cm*(gf1+gf2)+costo2cm*sintcm*(gf3+gf4))/root_two
	  H2 = (-2.*costo2cm*(gf1-gf2)+sinto2cm*sintcm*(gf3-gf4))/root_two
	  H1 = (-costo2cm*sintcm*(gf3+gf4))/root_two
	  H3 = ( sinto2cm*sintcm*(gf3-gf4))/root_two

* DJG Bartl helicity amplitudes (Bartl,Nuc.Phys.B62,267 (1973).)
* key:		hnperp -----> photon pol. perp. to scatt. plane,no baryon flip
*		hfpar -----> photon pol. par. to scatt. plane, baryon flip
*		hnlong -----> longitudinal photon pol., no baryon flip
*		hflong -----> longitudinal photon pol., baryon flip
*		hnpar -----> photon pol. par. to scatt. plane, no baryon flip
*		hfperp -----> photon pol. perp. to scatt. plane, baryon flip

	  hnperp = (H4+H1)/root_two
	  hfpar = (H3+H2)/root_two
	  hnlong = H5
	  hflong = H6
	  hnpar = (H4-H1)/root_two
	  hfperp = (H3-H2)/root_two

	  XT = hnperp*CONJG(hnperp)+hfpar*CONJG(hfpar)+hnpar*CONJG(hnpar)+
     >		hfperp*CONJG(hfperp)
	  XL = hnlong*CONJG(hnlong) + hflong*CONJG(hflong)
	  XTT = hnpar*CONJG(hnpar)+hfpar*CONJG(hfpar)-hnperp*CONJG(hnperp)-
     >		hfperp*CONJG(hfperp)
	  XLT = hnlong*CONJG(hnpar)+hflong*CONJG(hfpar)

	  F = 2.*((efer-pfer*tfcos)/1000.)*sqrt(s)*(ppicm/1000.)/
     >		(s-(targ.Mtar_struck/1000.)**2)/(targ.Mtar_struck/1000.)

	  sigt = F/2.*XT
	  sigl = F*XL
	  sigtt = F/2.*XTT
	  siglt = 2.*F*REAL(XLT)
	  siglt=siglt/2.	!Divide siglt by 2 because Henk uses
				!a different convention when adding
				!the four terms together. DJG

	  sig219=(sigt+epsi*sigl+epsi*cos(2.*phicm)*sigtt
     >		+sqrt(2.0*epsi*(1.+epsi))*cos(phicm)*siglt)/1.d0

* DJG: This is dsig/dOmega_cm - convert to dsig/dtdphi_cm
* DJG: using dt/dcos_cm = 2ppicmqcm

	  sig = sig219/ppicm/qstar/2.

	else		!If equivalent gamma energy too high
			!use Henk Blok's fit to Brauel data

* Fits to p(e,e'pi+)n cross-sections
* HPB: cross sections for pi-fits to Brauel's n(e,e'pi-)p
* HPB: dsigma/dt cross sections at W=2.19 and Q^2=0.70 MODIFIED BY HAND!!!

c	  sigl = 27.8*exp(-11.5*abs(t))
c	  sigt = 10.0*(5.*abs(t))*exp(-5.*abs(t))
c	  siglt= 0.0*sin(thetacm)
c	  sigtt= -(4.0*sigl+0.5*sigt)*(sin(thetacm))**2

c	  if (which_pion.eq.1 .or. which_pion.eq.11) then	!pi-
c	    sigt =sigt *0.25*(1.+3.*exp(-10.*abs(t)))
c	    sigtt=sigtt*0.25*(1.+3.*exp(-10.*abs(t)))
c	  endif

* GMH: Now scale sigl by Q2*pion_formfactor
* HPB: parametrization of pion formfactor in the region 0.5<Q2<1.8

c	  mrho = 0.712   !DETERMINED BY EMPIRICAL FIT TO FORMFACTOR (GeV/c**2)

c	  fpi=1./(1.+1.65*Q2_g+0.5*Q2_g**2)
c	  fpi2=fpi**2

* HPB: now convert to different Q^2
* HPB: s_L follows Q^2*Fpi^2; s_T and s_TT go as 1/(0.3+Q^2)?
* HPB: factor 0.1215 therefore is value of q2*fpi**2 for q2=0.7

c	  sigl=sigl*(fpi2*Q2_g)/0.1215
c	  sigt=sigt/(0.3+Q2_g)
c	  sigtt=sigtt/(0.3+Q2_g)

c	  sig219=(sigt+epsi*sigl+epsi*cos(2.*phicm)*sigtt
c     >		+sqrt(2.0*epsi*(1.+epsi))*cos(phicm)*siglt)/1.d0

* GMH: Brauel scaled all his data to W=2.19 GeV, so rescale by 1/(W**2-mp**2)**2
* HPB: factor 15.333 therefore is value of (W**2-mp**2)**2 at W=2.19

c	  sig=sig219*15.333/(s-(targ.Mtar_struck/1000.)**2)**2
c	  sig=sig/2./pi/1.d+06   !dsig/dtdphicm in microbarns/MeV**2/rad

C Jocen's new parameterization

cc	   sigl = 34.0*exp( (-23.5+6.0*Q2_g)*(abs(t)-0.02) )
cc	   sigt = 10.0/(Q2_g+Q2_g**2)*(1.0+4.0*abs(t)) - 
cc	1	4.0*sigl*sin(thetacm)**2
c	   siglt = (0.94 - 34.4*exp(-2.76*Q2_g) + 
c	1	171.0*exp(-113.9*abs(t)*exp(-0.75*Q2_g)))*sin(thetacm)
c	   sigtt = 2.22/Q2_g**2 * (-abs(t))/(-abs(t)-0.02) * sin(thetacm)**2
c
c	   if(sigt.lt.0.0) then
c	      sigt = 0.0
c	   endif
c	   sigtt = 0.0
c	   siglt = 0.0
c	   sig219=(sigt+epsi*sigl+epsi*cos(2.*phicm)*sigtt
c     >		+sqrt(2.0*epsi*(1.+epsi))*cos(phicm)*siglt)/1.d0
c	   sig=sig219/2./pi/1.d+06 !dsig/dtdphicm in microbarns/MeV**2/rad

c	   ntup.sigl = sigl
c	   ntup.sigt = sigt

	   if(first) then
	      first = .FALSE.
	      do j=1,8
		 OPEN(3,FILE=filename(j),STATUS='OLD')
		 Q2_tab(j) = 2.0 + (j-1)*0.5
		 write(6,*) 'reading regge file', j
		 do t_count = 1,130
		    read(3,*) t_tab(t_count), stab(j,t_count,1), 
	1		 stab(j,t_count,2), stab(j,t_count,3), 
	2		 stab(j,t_count,4)
		 enddo
		 close(unit=3)
		 write(6,*) 'done'
	      enddo
	   endif		!if first time.

	  q2_tmp = Q2_g
	  t_tmp = t
c* Interpolate multipole amplitudes from table.
	  do Q2_count=1,7
	     Q2_high=0.
	     Q2_low=0.
	     t_high=0.
	     t_low=0.
	     if(Q2_tmp.lt.Q2_tab(1)) then
		Q2_tmp = Q2_tab(1)
	     endif
	     if(Q2_tmp.gt.Q2_tab(8)) then
		Q2_tmp = Q2_tab(8)
	     endif
	     if(abs(t_tmp).lt.t_tab(1)) then
		t_tmp = -t_tab(1)
	     endif
	     if(abs(t_tmp).gt.t_tab(130)) then
		t_tmp = -t_tab(130)
	     endif
	     if((Q2_tmp.ge.Q2_tab(Q2_count)).and.
	1	  (Q2_tmp.lt.Q2_tab(Q2_count+1))) then
		Q2_high = Q2_tab(Q2_count+1)
		Q2_low = Q2_tab(Q2_count)
		deltaQ2 = (Q2_high-Q2_low)
		do t_count=1,129
		   if((abs(t_tmp).ge.t_tab(t_count)).and.
	1		(abs(t_tmp).lt.t_tab(t_count+1))) then
		      t_high = t_tab(t_count+1)
		      t_low =  t_tab(t_count)
		      delta_t = t_high-t_low
		      

		      do itab=1,4
			 A1 = stab(Q2_count,t_count,itab)
			 A2 = stab(Q2_count+1,t_count,itab)
			 A3 = stab(Q2_count,t_count+1,itab)
			 A4 = stab(Q2_count+1,t_count+1,itab)
			 A12= (A1*(Q2_high-Q2_tmp)+A2*(Q2_tmp-Q2_low))/deltaQ2
			 A34= (A3*(Q2_high-Q2_tmp)+A4*(Q2_tmp-Q2_low))/deltaQ2
			 A1234 = (A12*(t_high-abs(t_tmp))+
	1		      A34*(abs(t_tmp)-t_low))/delta_t
			 sinterp(itab) = A1234
		      enddo
		   endif	!t check
		enddo		!t
	     endif		!Q2 check
	  enddo			!Q2


	  sigt = sinterp(1)
	  sigl = sinterp(2)
	  sigtt = sinterp(3)
	  siglt = sinterp(4)

	  ntup.sigl = sigl
	  ntup.sigt = sigt

	  sig219=(sigt+epsi*sigl+epsi*cos(2.*phicm)*sigtt
     >		+sqrt(2.0*epsi*(1.+epsi))*cos(phicm)*siglt)/1.d0

* DJG: This is dsig/dOmega_cm - convert to dsig/dtdphi_cm
* DJG: using dt/dcos_cm = 2ppicmqcm
	  wfactor=(2.0**2-(targ.Mtar_struck/1000.)**2)**2/
	1      (s-(targ.Mtar_struck/1000.)**2)**2

	  sig = sig219*wfactor/ppicm/qstar/2.

	endif	!end test on high or low W

*******************************************************************************
* GMH: Virtual photon to electron beam flux conversion factor
* DJG: Replace targ.Mtar_struck in denominator of gammaflux with more general
* DJG: efer-pfer*tfcos, for pfer =0 this reverts to old form
c	gtpr = alpha/2./(pi**2)*vertex.e.E/vertex.Ein*(s-(targ.Mtar_struck/1000.)**2)/2./
c     >		(targ.Mtar_struck/1000.)/Q2_g/(1.-epsi)

	gtpr = alpha/2./(pi**2)*vertex.e.E/vertex.Ein*(s-(targ.Mtar_struck/1000.)**2)/2./
     >		((efer-pfer*tfcos)/1000.)/Q2_g/(1.-epsi)

* GH: Now determine momentum of pion in n-pi cm frame, needed to properly add
* GH: together the components of the cross-section

* Now, Henk's CM -> LAB transformation
* HPB: Brauel's cross section is expressed in an invariant way as dsigma/dtdphi,
* HPB: with a virtual photon flux factor based on a full cross section, written
* HPB: as: dsigma/dQ2dWdtdphi. One can convert this cross section to dsigma/domega
* HPB: in the lab frame or the cm frame by multiplying with the factor q*p_pi/3.14
* HPB: (with the variables in the lab frame, or the cm frame)
* HPB: this factor is built from dt/dcos(theta)=2pq, and a factor 1/2pi, which
* HPB: comes from the conversion of Brauel's virtual photon flux factor and the
* HPB: one we use, based on dsigma/dE_e'dOmega_e'dOmega_pi
* HPB: see Devenish and Lyth, Phys. Rev.  C D5, 47(1972)

* Simpler (I hope) explanation:  sig is d2sigma/dt/dphi_cm.  In order to get
* d2sigma/domega_cm (=s2cm), we multiply by dt/domega_cm = 1/2/pi*dt/dcos(theta_cm)
* = 1/pi*q_cm*p_cm.  We can then get d5sigma/dE_e'/dOmega_e'/dOmega_pi_cm by
* multiplying by gammav.  Either of these can be converted to the dOmega_lab
* by multiplying by dOmega_lab/dOmega_cm = dcos(theta_lab)/dcos(theta_cm)
* (dphi_cm/dphi_lab=1 since the frames are collinear).  This is 'factor',
* which is equal to dt/dcos(theta_cm) / dt/dcos(theta_lab).  Hence, the
* following cross sections can be calculated:
*	s2cm =       sig*qcm*ppicm       /pi
*	s5cm =gammav*sig*qcm*ppicm       /pi
*	s2lab=       sig*q  *ppi  *factor/pi
*	s5lab=gammav*sig*q  *ppi  *factor/pi

	factor=targ.Mtar_struck/(targ.Mtar_struck+vertex.omega-vertex.q*vertex.p.E/vertex.p.P*tcos)
	s5lab = gtpr*sig*vertex.q*vertex.p.P*factor/pi/1.d+06

* DJG The above assumes target at rest.  We need a full blown Jacobian:
* DJG | dt/dcos(theta) dphicm/dphi - dt/dphi dphicm/dcos(theta) |
* DJG: Calculate dt/d(cos(theta)) and dt/dphi for the general case.

	psign = cos(phiqn)*cospq+sin(phiqn)*sinpq

	square_root = vertex.q + pfer*tfcos - vertex.p.P*tcos
	dp_dcos_num = vertex.p.P + (vertex.p.P**2*tcos -
     >		psign*pfer*vertex.p.P*tfsin*tcos/tsin)/square_root
	dp_dcos_den = ( (vertex.omega+efer-vertex.p.E)*vertex.p.P/vertex.p.E +
     >		vertex.p.P*tsin**2-psign*pfer*tfsin*tsin )/square_root - tcos
	dp_dcos = dp_dcos_num/dp_dcos_den

	dp_dphi_num = pfer*vertex.p.P*tsin*tfsin*(cos(phiqn)*sinpq-
     >		sin(phiqn)*cospq)/square_root
	dp_dphi_den = tcos + (pfer*tsin*tfsin*psign - vertex.p.P*tsin**2
     >		- (vertex.omega+efer-vertex.p.E)*vertex.p.P/vertex.p.E)/square_root
	dp_dphi = dp_dphi_num/dp_dphi_den

	dt_dcos_lab = 2.*(vertex.q*vertex.p.P +
     >		(vertex.q*tcos-vertex.omega*vertex.p.P/vertex.p.E)*dp_dcos)

	dt_dphi_lab = 2.*(vertex.q*tcos-vertex.omega*vertex.p.P/vertex.p.E)*dp_dphi

* DJG: Now calculate dphicm/dphi and dphicm/d(cos(theta)) in the most
* DJG: excruciating way possible.

	dpxdphi = vertex.p.P*tsin*(-sinpq+(gstar-1.)*bstarx/bstar**2*
     >		(bstary*cospq-bstarx*sinpq) ) +
     >		( (ppicmx+gstar*bstarx*vertex.p.E)/vertex.p.P -
     >		gstar*bstarx*vertex.p.P/vertex.p.E)*dp_dphi
	dpydphi = vertex.p.P*tsin*(cospq+(gstar-1.)*bstary/bstar**2*
     >		(bstary*cospq-bstarx*sinpq) ) +
     >		( (ppicmy+gstar*bstary*vertex.p.E)/vertex.p.P -
     >		gstar*bstary*vertex.p.P/vertex.p.E)*dp_dphi
	dpzdphi =  vertex.p.P*(gstar-1.)/bstar**2*bstarz*tsin*
     >		(bstary*cospq-bstarx*sinpq) +
     > 		((ppicmz+gstar*bstarz*vertex.p.E)/vertex.p.P-
     >		gstar*bstarz*vertex.p.P/vertex.p.E)*dp_dphi

	dpxdcos = -vertex.p.P*tcos/tsin*(cospq+(gstar-1.)*bstarx/bstar**2*
     >		(bstarx*cospq+bstary*sinpq-bstarz*tsin/tcos)) +
     >		( (ppicmx+gstar*bstarx*vertex.p.E)/vertex.p.P -
     >		gstar*bstarx*vertex.p.P/vertex.p.E)*dp_dcos
	dpydcos = -vertex.p.P*tcos/tsin*(sinpq+(gstar-1.)*bstary/bstar**2*
     >		(bstarx*cospq+bstary*sinpq-bstarz*tsin/tcos)) +
     >		( (ppicmy+gstar*bstary*vertex.p.E)/vertex.p.P -
     >		gstar*bstary*vertex.p.P/vertex.p.E)*dp_dcos
	dpzdcos = vertex.p.P*(1.-(gstar-1.)/bstar**2*bstarz*tcos/tsin*
     >		(bstarx*cospq+bstary*sinpq-tsin/tcos*bstarz))
     >		+((ppicmz+gstar*bstarz*vertex.p.E)/vertex.p.P-gstar*bstarz*
     >		vertex.p.P/vertex.p.E)*dp_dcos

	dpxnewdphi = dpxdphi*new_x_x+dpydphi*new_x_y+dpzdphi*new_x_z
	dpynewdphi = dpxdphi*new_y_x+dpydphi*new_y_y+dpzdphi*new_y_z
	dpznewdphi = dpxdphi*new_z_x+dpydphi*new_z_y+dpzdphi*new_z_z

	dphicmdphi = (dpynewdphi*ppicm_newx - ppicm_newy*dpxnewdphi)/
     >			(ppicm_newx**2+ppicm_newy**2)

	dpxnewdcos = dpxdcos*new_x_x+dpydcos*new_x_y+dpzdcos*new_x_z
	dpynewdcos = dpxdcos*new_y_x+dpydcos*new_y_y+dpzdcos*new_y_z
	dpznewdcos = dpxdcos*new_z_x+dpydcos*new_z_y+dpzdcos*new_z_z

	dphicmdcos = (dpynewdcos*ppicm_newx - ppicm_newy*dpxnewdcos)
     >			/(ppicm_newx**2+ppicm_newy**2)

	dcoscmdcos = dpznewdcos/ppicm-ppicm_newz*epicm*dEcmdcos/ppicm**1.5
	dcoscmdphi = dpznewdphi/ppicm-ppicm_newz*epicm*dEcmdphi/ppicm**1.5

	jacobian = abs(dt_dcos_lab*dphicmdphi-dt_dphi_lab*dphicmdcos)
	main.davejac = jacobian

	main.johnjac = 2*(efer-2*pferz*pfer*vertex.p.E/vertex.p.P*tcos)*
     >		(vertex.q+pferz*pfer)*vertex.p.P /
     >		( efer+vertex.omega-(vertex.q+pferz*pfer)*vertex.p.E/vertex.p.P*tcos )
     >		- 2*vertex.p.P*pfer

	davesig = gtpr*sig*jacobian
c	write(6,*) 'XSEC (ub/sr2/GeV), gammaflux', davesig,gtpr
c	write(6,*) 'Q2,W,t',Q2_g,sqrt(s),t
c	write(6,*) gtpr*jacobian
	sigma_eepi = davesig/1.d3	!ub/GeV-sr --> ub/MeV-sr
	peepi = sigma_eepi
	ntup.sigcm = sig	!sig_cm
	first=.false.

202	format(/11X,f5.1/)
203	format(11X,f5.0)
204	format(6(/9X,7f8.3))

	return
	end

!------------------------------------------------------------------------

	real*8 function sigep(vertex)

! elastic cross section, units are set by sigMott.f (microbarn/sr)

	implicit none
	include 'simulate.inc'

	real*8	q4sq,qmu4mp,W1p,W2p,Wp,GE,GM,sigMott
	record /event/	vertex

	q4sq	= vertex.Q2
	call fofa_best_fit(-q4sq/hbarc**2,GE,GM)
	qmu4mp	= q4sq/4./Mp2
	W1p = GM**2*qmu4mp
	W2p = (GE**2+GM**2*qmu4mp)/(1.0+qmu4mp)
	Wp = W2p + 2.*W1p*tan(vertex.e.theta/2.)**2
	sigep = sigMott(vertex.e.E,vertex.e.theta,vertex.q2) *
     >		vertex.e.E/vertex.Ein * Wp
	if (debug(5)) write(6,*) 'sigMott',GE,GM
	return
	end

!-------------------------------------------------------------------------

	real*8 function deForest(ev)

	implicit none
	include 'simulate.inc'

	record /event/	ev

	real*8	q4sq,ebar,qbsq,GE,GM,f1,kf2,qmu4mp,sigMott,sin_gamma,cos_phi
	real*8	pbarp,pbarq,pq,qbarq,q2,f1sq,kf2_over_2m_allsq
	real*8	sumFF1,sumFF2,termC,termT,termS,termI,WC,WT,WS,WI,allsum

! Compute deForest sigcc cross-section, according to value of DEFOREST_FLAG:
!	Flag = 0    -- use sigcc1
!	Flag = 1    -- use sigcc2
!	Flag = -1   -- use sigcc1 ONSHELL, replacing Ebar with E = E'-omega
!			and qbar with q (4-vector)
! N.B.	Beware of deForest's metric when taking all those 4-vector inner
!	products in sigcc2 ... it is (-1,1,1,1)!
!	Here, I've defined all the inner products with the regular signs,
!	and then put them in the structure function
!	formulas with reversed signs compared to deForest.
!
! Note that this can be called with either the vertex or recon event records,
! but like a good function, it does not modify anything in those records.
!
! JRA: Note, let me make a comment about the following, because I was badly
! confused about it the first time through.  The 6-fold cross section is:
! d6sigma = K * S(E,p) * sigma_eN.  This routine returns a quantity 'deForest'
! which is d6sigma/S(E,p) = K*sigma_eN
! = (E'*p')*sigma_mott*[sum of terms like a_i*W_i].
! Each W_i term has E'/Ebar in it.  In the following code, the E'/Ebar appears
! to have been removed from the W_i terms, and combined with the K=E'*p' term
! to give an overall p'/Ebar in the final expression.
! More importantly, since the Spectral Function has been divided out, the
! units are MeV^4 * the 6-fold cross section units, and so for sigma_mott
! in microbarn/sr, 'deForest' is in microbarn*MeV^2/sr^2, giving the correct
! cross seciton units once we multiply by S(E,p) which is in MeV^-4

	q4sq = -ev.Q2
	q2 = ev.q**2
	if (deForest_flag.ge.0) then
	  ebar = sqrt(ev.Pm**2 + Mh2)
	  qbsq = (ev.p.E-ebar)**2 - q2
	else
	  ebar = ev.p.E - ev.omega
	  qbsq = q4sq
	endif

	sin_gamma = 1. - (ev.uq.x*ev.up.x+ev.uq.y*ev.up.y+ev.uq.z*ev.up.z)**2
	if (sin_gamma.lt.0) then
	  write(6,'(1x,''WARNING: deForest came up with sin_gamma = '',f10.3,'' at event '',i10)') sin_gamma, nevent
	  sin_gamma = 0.0
	endif
	sin_gamma = sqrt(sin_gamma)
	cos_phi = 0.0
	if (sin_gamma.ne.0) cos_phi=(ev.uq.y*(ev.uq.y*ev.up.z-ev.uq.z*ev.up.y)
     >		- ev.uq.x*(ev.uq.z*ev.up.x-ev.uq.x*ev.up.z))
     >		/ sin_gamma / sqrt(1.-ev.uq.z**2)
	if (abs(cos_phi).gt.1.) then		!set to +/-1, warn if >1.e-10
	  cos_phi = sign(1.0,cos_phi)
	  if ( (abs(cos_phi)-1.) .gt. 1.e-10) write(6,*)
     >		'WARNING: deForest give cos_phi = ',cos_phi,' at event',nevent
	endif

	call fofa_best_fit(q4sq/hbarc**2,GE,GM)
	qmu4mp = q4sq/4./Mp2
	f1 = (GE-GM*qmu4mp)/(1.0-qmu4mp)
	kf2 = (GM-GE)/(1.0-qmu4mp)
	f1sq = f1**2
	kf2_over_2m_allsq = kF2**2/4./Mh2

	termC = (q4sq/q2)**2
	termT = (tan(ev.e.theta/2.))**2 - q4sq/2./q2
	termS = tan(ev.e.theta/2.)**2 - (q4sq/q2)*cos_phi**2
	termI = (-q4sq/q2)*sqrt(tan(ev.e.theta/2.)**2-q4sq/q2)*cos_phi

	if (deForest_flag.le.0) then
	  sumFF1 = (f1 + kf2)**2
	  sumFF2 = f1sq - qbsq*kf2*kf2/4./Mh2

	  WC = ((ebar+ev.p.E)**2)*sumFF2 - q2*sumFF1
	  WT = -2*qbsq*sumFF1
	  WS = 4*(ev.p.P**2)*(sin_gamma**2)*sumFF2
	  WI = -4*(ebar+ev.p.E)*ev.p.P*sin_gamma*sumFF2
	else
	  pbarp=ebar*ev.p.E-ev.p.p*(ev.up.x*ev.Pmx+ev.up.y*ev.Pmy+ev.up.z*ev.Pmz)
	  pbarq=ebar*ev.omega-ev.q*(ev.uq.x*ev.Pmx+ev.uq.y*ev.Pmy+ev.uq.z*ev.Pmz)
	  pq = ev.p.E*ev.omega - ev.p.p * ev.q * (ev.up.x*ev.uq.x +
     >		ev.up.y*ev.uq.y + ev.up.z*ev.uq.z)
	  qbarq = (ev.p.E-ebar)*ev.omega - q2

	  WC =	(ebar*ev.p.E+(-pbarp+Mh2)/2.) * f1sq - q2*f1*kf2/2.
     >		- ( (-pbarq*ev.p.E-pq*ebar)*ev.omega + ebar*ev.p.E*q4sq +
     >		pbarq*pq - (-pbarp-Mh2)/2.*q2 ) * kf2_over_2m_allsq
	  WT =	- (-pbarp+Mh2)*f1sq - qbarq*f1*kF2
     >		+ (2.*pbarq*pq + (-pbarp-Mh2)*q4sq) * kf2_over_2m_allsq
	  WS =	(ev.p.p*sin_gamma)**2 * (f1sq - q4sq*kf2_over_2m_allsq)
	  WI =	ev.p.p*sin_gamma * ( -(ebar+ev.p.E)*f1sq + ((-pbarq-pq)*
     >		ev.omega+(ebar+ev.p.E)*q4sq)*kf2_over_2m_allsq )
	endif

	allsum = termC*WC + termT*WT + termS*WS + termI*WI
	if (deForest_flag.le.0) allsum = allsum/4.0
	deForest = sigMott(ev.e.E,ev.e.theta,ev.Q2)*ev.p.P*allsum/ebar	!microbarn*(MeV/sr)**2
	if (debug(5)) write(6,*) 'deForest',GE,GM

	return
	end

!-------------------------------------------------------------------------

	subroutine fofa_best_fit(qsquar,GE,GM)

*	csa 9/14/98 -- This calculates the form factors Gep and Gmp using
*	Peter Bosted's fit to world data (Phys. Rev. C 51, 409, Eqs. 4
*	and 5 or, alternatively, Eqs. 6)

	implicit none
	include 'simulate.inc'

	real*8  qsquar,GE,GM,mu_p
	real*8  Q,Q2,Q3,Q4,Q5,denom

	mu_p = 2.793

	Q2 = -qsquar*(hbarc**2.)*1.d-6
	Q  = sqrt(max(Q2,0.d0))

	Q3 = Q**3.
	Q4 = Q**4.
	Q5 = Q**5.

* Use Eqs 4, 5:
	denom = 1. + 0.62*Q + 0.68*Q2 + 2.8*Q3 + 0.83*Q4
	GE = 1./denom
	denom = 1. + 0.35*Q + 2.44*Q2 + 0.5*Q3 + 1.04*Q4 + 0.34*Q5
	GM = mu_p/denom

* OR Eqs 6:
*	denom = 1. + 0.14*Q + 3.01*Q2 + 0.02*Q3 + 1.20*Q4 + 0.32*Q5
*	GE = 1./denom
*	GM = mu_p/denom

	return
	end


!-------------------------------------------------------------------------

	real*8 function sigMott(e0,theta,Q2)

	implicit none
	include 'constants.inc'

	real*8 e0,theta,Q2
	real*8 sig

! The Mott cross section (for a point nucleus) in microbarns/sr.

	sig = (2.*alpha*hbarc*e0*cos(theta/2.)/Q2 )**2
	sigMott = sig*1.d4	!fm**2 --> microbarns

	return
	end
