(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 3.0,
MathReader 3.0, or any compatible application. The data for the notebook 
starts with the line of stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     43186,       1387]*)
(*NotebookOutlinePosition[     43962,       1414]*)
(*  CellTagsIndexPosition[     43918,       1410]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[{
    \(sigma := 10\), 
    \(Ezero := 1000. \), 
    \(ezeroprime := Ezero\  - \ eprime\)}], "Input"],

Cell[BoxData[
    \(\(\npgauss := \ 
      1/\((sigma*Sqrt[2*Pi])\)\ 
        Exp[\(-0.5\)*\((\((Energy - ezeroprime)\)/sigma)\)^2]\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[pgauss, {Energy, 950, 1050}, PlotPoints -> 100]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-9.02381 0.00952381 0.0147151 14.7541 [
[.30952 .00222 -9 -9 ]
[.30952 .00222 9 0 ]
[.5 .00222 -12 -9 ]
[.5 .00222 12 0 ]
[.69048 .00222 -12 -9 ]
[.69048 .00222 12 0 ]
[.88095 .00222 -12 -9 ]
[.88095 .00222 12 0 ]
[.10655 .16226 -24 -4.5 ]
[.10655 .16226 0 4.5 ]
[.10655 .3098 -24 -4.5 ]
[.10655 .3098 0 4.5 ]
[.10655 .45734 -24 -4.5 ]
[.10655 .45734 0 4.5 ]
[.10655 .60488 -24 -4.5 ]
[.10655 .60488 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .01472 m
.30952 .02097 L
s
[(980)] .30952 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(1000)] .5 .00222 0 1 Mshowa
.69048 .01472 m
.69048 .02097 L
s
[(1020)] .69048 .00222 0 1 Mshowa
.88095 .01472 m
.88095 .02097 L
s
[(1040)] .88095 .00222 0 1 Mshowa
.125 Mabswid
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.07143 .01472 m
.07143 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.97619 .01472 m
.97619 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.11905 .16226 m
.1253 .16226 L
s
[(0.01)] .10655 .16226 1 0 Mshowa
.11905 .3098 m
.1253 .3098 L
s
[(0.02)] .10655 .3098 1 0 Mshowa
.11905 .45734 m
.1253 .45734 L
s
[(0.03)] .10655 .45734 1 0 Mshowa
.11905 .60488 m
.1253 .60488 L
s
[(0.04)] .10655 .60488 1 0 Mshowa
.125 Mabswid
.11905 .04422 m
.1228 .04422 L
s
.11905 .07373 m
.1228 .07373 L
s
.11905 .10324 m
.1228 .10324 L
s
.11905 .13275 m
.1228 .13275 L
s
.11905 .19176 m
.1228 .19176 L
s
.11905 .22127 m
.1228 .22127 L
s
.11905 .25078 m
.1228 .25078 L
s
.11905 .28029 m
.1228 .28029 L
s
.11905 .33931 m
.1228 .33931 L
s
.11905 .36881 m
.1228 .36881 L
s
.11905 .39832 m
.1228 .39832 L
s
.11905 .42783 m
.1228 .42783 L
s
.11905 .48685 m
.1228 .48685 L
s
.11905 .51635 m
.1228 .51635 L
s
.11905 .54586 m
.1228 .54586 L
s
.11905 .57537 m
.1228 .57537 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .01472 m
.02837 .01472 L
.03318 .01472 L
.03805 .01472 L
.04339 .01472 L
.04813 .01472 L
.05321 .01472 L
.05838 .01473 L
.06326 .01473 L
.07257 .01474 L
.07738 .01475 L
.08248 .01475 L
.09165 .01478 L
.09635 .01479 L
.10142 .01481 L
.10619 .01483 L
.11141 .01486 L
.12104 .01493 L
.12581 .01498 L
.13089 .01504 L
.13573 .01511 L
.14097 .0152 L
.15068 .01542 L
.16062 .01574 L
.1702 .01618 L
.1794 .01675 L
.1892 .01758 L
.19863 .01866 L
.20866 .02018 L
.21832 .02213 L
.22761 .02457 L
.2375 .0279 L
.24702 .032 L
.25617 .03692 L
.26592 .04342 L
.27529 .05111 L
.28527 .06105 L
.29487 .07259 L
.30411 .0857 L
.31395 .10203 L
.32341 .12022 L
.33347 .14233 L
.34316 .1664 L
.35249 .19209 L
.36241 .22201 L
.37196 .25313 L
.38115 .28488 L
.39092 .3202 L
.40034 .35514 L
.41034 .39262 L
Mistroke
.41998 .42827 L
.42925 .4614 L
.43912 .49455 L
.44862 .5236 L
.45871 .55052 L
.46844 .57187 L
.4778 .58754 L
.48264 .59362 L
.48511 .59617 L
.48775 .59847 L
.49024 .60024 L
.49252 .60151 L
.49361 .602 L
.4948 .60244 L
.49585 .60276 L
.49697 .60302 L
.49758 .60313 L
.49815 .60321 L
.49868 .60326 L
.49895 .60328 L
.49925 .6033 L
.49942 .60331 L
.49958 .60331 L
.49988 .60332 L
.50005 .60332 L
.50021 .60332 L
.50038 .60331 L
.50056 .60331 L
.50086 .6033 L
.50113 .60328 L
.50144 .60325 L
.50177 .60322 L
.50242 .60313 L
.50314 .603 L
.50443 .60268 L
.5057 .60227 L
.50687 .60179 L
.5092 .60058 L
.51138 .59913 L
.51638 .59468 L
.52126 .58883 L
.52575 .5822 L
.53535 .56415 L
.54458 .54225 L
.5544 .51472 L
.56386 .48482 L
.57391 .45027 L
.5836 .41514 L
.59291 .38043 L
.60283 .34334 L
Mistroke
.61237 .30816 L
.62155 .27541 L
.63132 .24222 L
.64072 .21229 L
.65072 .18297 L
.66035 .15736 L
.66962 .13524 L
.67947 .11441 L
.68896 .09693 L
.69905 .08098 L
.70877 .06797 L
.71812 .05746 L
.72806 .04818 L
.73764 .04089 L
.74685 .03518 L
.75666 .0303 L
.76609 .02659 L
.77612 .02352 L
.78579 .02124 L
.79509 .01956 L
.80498 .01821 L
.8145 .01724 L
.82366 .01654 L
.83341 .016 L
.84279 .01562 L
.84756 .01547 L
.85277 .01533 L
.86238 .01514 L
.86714 .01506 L
.87222 .015 L
.87705 .01495 L
.88228 .0149 L
.89198 .01484 L
.8968 .01482 L
.90191 .0148 L
.9111 .01477 L
.91581 .01476 L
.92088 .01475 L
.92567 .01474 L
.93089 .01474 L
.94053 .01473 L
.94532 .01473 L
.95041 .01472 L
.95561 .01472 L
.9605 .01472 L
.96506 .01472 L
.96987 .01472 L
.97619 .01472 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/@P10`4000010?ooo`000063aP00002h
Z2iLF0EkL:Cek/c<c6IVIXR8R?GemE>6Rl30`61PH?oo0=:dS6UJA_ola?o[cDQ0B920T=WIfK>c/`00
ogmoOlZcbS9UI@3o08]gI@1T0;:b/X20P000P6@0080004:JYkZPY`0g?0200020P03ooaYOIbmnR800
P8200?l00?l0o`00kUDJRoooc=>e]@00_nOWifm_Kn7QhFEUIINGUnoShgYYJFVe]L3Ph3USHj>SX`00
<`00IP00V@00c00c000c<`0cIP0cV@0cc00co`1V001V<`1VIP1VV@1Vc01Vo`2I002I<`2IIP2IV@2I
c02Io`3<003<<`3<IP3<V@3<c03<o`3o<`3oIP3oV@3oc4000400<d00IT00VD00c400od0c040c<d0c
IT0cVD0cc40cod1V041V<d1VIT1VVD1Vc41Vod2I042I<d2IIT2IVD2Ic42Iod3<043<<d3<IT3<VD3<
c43<od3o043o<d3oIT3oVD3oc43ooh00<h00IX00VH00c800oh0c080c<h0cIX0cVH0cc80coh1V081V
<h1VIX1VVH1Vc81Voh2I082I<h2IIX2IVH2Ic82Ioh3<083<<h3<IX3<VH3<c83<oh3o083o<h3oIX3o
VH3oc83ookl00;l0<kl0I[l0VKl0c;l0oklc0;lc<klcI[lcVKlcc;lcokmV0;mV<kmVI[mVVKmVc;mV
oknI0;nI<knII[nIVKnIc;nIoko<0;o<<ko<I[o<VKo<c;o<okoo0;oo<kooI[ooVKooc;ooool0<ol0
I_l0VOl0c?lc0?lc<olcI_lcVOlcc?lcoomV0?mV<omVI_mVVOmVc?mVoonI0?nI<onII_nIVOnIc?nI
ooo<0?o<<oo<I_o<VOo<c?o<oooo<oooI_ooVG:OolCGociGS667fLc<Xhb<L?m50=WI[TnDcGMgMda<
C71`o`00L000fLC4a>[ZjW1`L:j^[WAdM8b<S:NWYj0Pl?l08@000?l08@000?l08@0005<00`440081
10020B801043008110020@@00P4O00@10`020@<0104300817P040@<00P4500030@0000800P4P0000
EP001040004200040@000@8000<100008@001@400001008000@100010P001040004200030@0001h0
00D100000@0200040@000@D000@100017`001@400001008000<100000P001@400001008000<10000
7@0005H000@100010P001040004200030@00024000D100000@0200040@000@8000@100010P000`40
000N00050@0000400P001@40000100@000@100017`001@400001008000<10040104200040@000Al0
001D00<10`020@<000@100018`001@400001008000@100010P001040004200030@0001h000D10000
0@0200030@00008000D100000@0200030@0001d000D100000@0200030@01008000D100000@020003
0@0001d0001C00040@000@8000@100010P001040004S00050@0000400P001040004200040@000@80
00<100007P001@400001008000<100000`001040004200030@0001d000D100000@0200060@000@01
0`001040004O0000:0000`40000X00040@000@8000@100010P001040004Q00<10`00104000420004
0@000@8000@100017P030@<000@100010P001040004200040@000Ad00`4300040@000@<00P430004
0@000Al0000X00030@0002T00P44008110020B@000<100000P020@@00P4400818@000`4000020081
10020@@00P4P00030@0000800P4500030@0000800P4P0000:0000`40003e0000:0000`40003e0000
1`3o0A81200000h000<100002P000`40000:00030@0000X000<100402`4;00030@0000X000<10000
2P000`40000:00030@0000X000<100002P000`40000:00030@0000X000<100002P000`40000:0003
0@0000X000<100002@000`400@070@<000<100002P000`40000:00030@0000X000<100003@0002P0
00<100005`020AL000<10000<@000`40000a00030@0001<01@4H00030@0002L0000X00030@0001T0
0`6?00<1A`0002P000<1000070020H/00P5:0000:0000`40000N00<1QP020D`0000X00030@000240
0P620081CP0002P000<100008`020Gl000<10000CP0002P00P4V00030@0007/000<10000C`0002P0
00<100009P000`40001i00030@000500000X00030@0002L000<10000M`000`40001A0000:0000`40
000X00030@0007D000<10000DP0002P000<10000:@000`40001c00030@0005<0000X00030@0002X0
00<10000L@000`40001D0000:0000`40000[00030@0006l000<10000E@0002P000<10000:`000`40
001^00030@0005H0000X0081;@000`40001]00030@0005H0000X00030@0002d000<10000J`000`40
001G0000:0000`40000^00030@0006T000<10000F00002P000<10000;`000`40001W00030@0005T0
000X00030@00030000<10000IP000`40001I0000:0000`40000`00030@0006D000<10000FP0002P0
00<10000<@000`40001S00030@0005/0000X00030@00034000<10000H`000`40001K0000:0020C<0
00<10000H@000`40001L0000:0000`40000b00030@00064000<10000G00002P000<10000<`000`40
001O00030@0005d0000X00030@0003<000<10000G`000`40001M0000:0000`40000d00030@0005h0
00<10000G@0002P000<10000=0000`40001M00030@0005h0000X00030@0003D000<10000G0000`40
001N0000:0000`40000e00030@0005/000<10000G`0002P00P4g00030@0005X000<10000G`0002P0
00<10000=P000`40001I00030@000600000X00030@0003L000<10000F0000`40001P0000:0000`40
000g00030@0005L000<10000H@0002P000<10000=`000`40001G00030@000640000X00030@0003P0
00<10000E@000`40001R0000:0000`40000h00030@0005D000<10000HP0000h00P4400030@0000<0
0P4300@11@000`40000h00030@0005@000<10000H`0000d000@1000120001040004400030@0000@0
0P4j00030@0005<000<10000H`0000d000@1000120001040004400030@0000@000<10000>@000`40
001B00030@0006@0000=00040@000@P000@1000110000`40000400030@0003T000<10000DP000`40
001T00003@001040004800040@000@@000<1000010000`40000j00030@00054000<10000I00000d0
00@1000120001040004200<11P000`40000j00030@00054000<10000I00000h00P4:00811@000`40
000400030@0003/000<10000C`000`40001U0000:0000`40000k00030@0004l000<10000I@0002P0
00<10000?0000`40001>00030@0006D0000X0081?@000`40001=00030@0006H0000X00030@0003`0
00<10000C@000`40001V0000:0000`40000m00030@0004`000<10000IP0002P000<10000?@000`40
001;00030@0006L0000X00030@0003h000<10000BP000`40001W0000:0000`40000n00030@0004T0
00<10000J00002P000<10000?P000`40001900030@0006P0000X00030@0003l000<10000B0000`40
001X0000:0020D0000<10000B0000`40001X0000:0000`40000o00030@0004L000<10000J@0002P0
00<10000?`000`40001700030@0006T0000X00030@00040000<10000AP000`40001Y0000:0000`40
001000030@0004H000<10000J@0002P000<10000@0000`40001500030@0006X0000X00030@000400
00<10000A@000`40001Z0000:0000`40001100030@0004@000<10000JP0002P00P5200030@0004<0
00<10000J`0002P000<10000@@000`40001300030@0006/0000X00030@00044000<10000@`000`40
001[0000:0000`40001200030@00044000<10000K00002P000<10000@P000`40001100030@0006`0
000X00030@0004<000<10000@0000`40001/0000:0000`40001300030@0003l000<10000K@0002P0
00<10000@`000`40000o00030@0006d0000X0081A@000`40000n00030@0006d0000X00030@0004@0
00<10000?@000`40001^0000:0000`40001400030@0003d000<10000KP0002P000<10000A0000`40
000m00030@0006h0000X00030@0004D000<10000>`000`40001_0000:0000`40001500030@0003/0
00<10000K`0002P000<10000A@000`40000k00030@0006l0000>008110000`40000300810`040@D0
00<10000A@000`40000j00030@000700000=00040@000@P000@100010P000`4000060081AP000`40
000j00030@000700000=00040@000@P000@100010`000`40000500030@0004H000<10000>@000`40
001`00003@001040004800040@000@@000<1000010000`40001600030@0003T000<10000L00000d0
00@1000120001040004500030@0000<000<10000AP000`40000h00030@000740000=00040@000@P0
00@100010P001040004500030@0004H000<10000>0000`40001a00003P020@X00P4400811P000`40
001700030@0003L000<10000L@0002P000<10000A`000`40000g00030@000740000X00030@0004L0
00<10000=P000`40001b0000:0020DT000<10000=@000`40001b0000:0000`40001800030@0003D0
00<10000LP0002P000<10000B0000`40000e00030@000780000X00030@0004T000<10000<`000`40
001c0000:0000`40001900030@0003<000<10000L`0002P000<10000B@000`40000c00030@0007<0
000X00030@0004X000<10000<P000`40001c0000:0000`40001:00030@00034000<10000M00002P0
0P5;00030@00034000<10000M00002P000<10000B`000`40000`00030@0007@0000X00030@0004/0
00<10000;`000`40001e0000:0000`40001;00030@0002l000<10000M@0002P000<10000B`000`40
000_00030@0007D0000X00030@0004`000<10000;P000`40001e0000:0000`40001<00030@0002d0
00<10000MP0002P000<10000C0000`40000]00030@0007H0000X0081C@000`40000]00030@0007H0
000X00030@0004d000<10000;0000`40001f0000:0000`40001=00030@0002`000<10000MP0002P0
00<10000C@000`40000[00030@0007L0000X00030@0004d000<10000:`000`40001g0000:0000`40
001=00030@0002/000<10000M`0002P000<10000CP000`40000Z00030@0007L0000X00030@0004h0
00<10000:@000`40001h0000:0020Dl000<10000:@000`40001h0000:0000`40001>00030@0002T0
00<10000N00002P000<10000C`000`40000W00030@0007T0000X00030@0004l000<100009`000`40
001i0000:0000`40001?00030@0002L000<10000N@0002P000<10000D0000`40000U00030@0007X0
000X00030@00050000<100009@000`40001j00003P020@@000<100000`020@@00P4600030@000500
00<100009@000`40001j00003@001040004800040@000@8000@100011@020E8000<100008`000`40
001k00003@001040004800040@000@D000<100000`000`40001A00030@0002<000<10000N`0000d0
00@1000120001040004300811P000`40001A00030@0002<000<10000N`0000d000@1000120001040
004500030@0000<000<10000D@000`40000R00030@0007`0000=00040@000@P000@100010P001040
004500030@00058000<100008@000`40001l00003P020@X00P4400811P000`40001B00030@000240
00<10000O00002P000<10000DP000`40000P00030@0007d0000X00030@00058000<1000080000`40
001m0000:0020E@000<100007`000`40001m0000:0000`40001C00030@0001l000<10000O@0002P0
00<10000D`000`40000N00030@0007h0000X00030@0005<000<100007P000`40001n0000:0000`40
001D00030@0001d000<10000OP0002P000<10000E0000`40000M00030@0007h0000X00030@0005D0
00<100006`000`40001o0000:0000`40001E00030@0001/000<10000O`0002P00P5F00030@0001/0
00<10000O`0002P000<10000EP000`40000J00030@0007l0000X00030@0005H000<100006@000`40
00200000:0000`40001F00030@0001T000<10000P00002P000<10000E`000`40000G00030@000840
000X00030@0005L000<100005`000`4000210000:0000`40001H00030@0001D000<10000PP0002P0
00<10000F0000`40000E00030@000880000X0081FP000`40000D00030@000880000X00030@0005T0
00<100004`000`4000230000:0000`40001I00030@0001<000<10000P`0002P000<10000FP000`40
000B00030@0008<0000X00030@0005X000<100004@000`4000240000:0000`40001J00030@000140
00<10000Q00002P000<10000F`000`40000?00030@0008D0000X00030@0005/000<100003`000`40
00250000:0020Ed000<100003@000`4000260000:0000`40001M00030@0000`000<10000QP0002P0
00<10000G@000`40000;00030@0008L0000X00030@0005h000<100002P000`4000270000:0000`40
001O00030@0000L00P6:0000:0000`40001O00030@0000H000<10000RP0002P000<10000H0020@D0
00<10000R`0000h00P4400030@0000<00P4500030@0000@000<10000H@060Hh0000=00040@000@P0
00@1000110000`4000040081I0030Hl0000=00040@000@P000D1000100050@D000<10000m@0000d0
00@1000120001P4000400@8000<1000010000`40003e00003@001040004800040@000@8000<10040
1P000`40003e00003@001040004800040@000@<00P4600030@000?D00000\
\>"],
  ImageRangeCache->{{{91.5625, 320.938}, {303.375, 162.062}} -> {899.998, 
  0.0476212, 0.387886, 0.000250381}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(lambda :=  .5*\((eprime\  - \ 2)\)\ \)\)], "Input"],

Cell[BoxData[
    \(plandau\  := \ 
      1/\((2\ Pi)\)\ \ Exp[\(-\((lambda\  + \ Exp[\(-lambda\)])\)\)]\)], 
  "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[plandau, \ {eprime, 0. , 15}]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0634921 0.0147151 10.0531 [
[.15079 .00222 -3 -9 ]
[.15079 .00222 3 0 ]
[.27778 .00222 -3 -9 ]
[.27778 .00222 3 0 ]
[.40476 .00222 -3 -9 ]
[.40476 .00222 3 0 ]
[.53175 .00222 -3 -9 ]
[.53175 .00222 3 0 ]
[.65873 .00222 -6 -9 ]
[.65873 .00222 6 0 ]
[.78571 .00222 -6 -9 ]
[.78571 .00222 6 0 ]
[.9127 .00222 -6 -9 ]
[.9127 .00222 6 0 ]
[.01131 .11525 -24 -4.5 ]
[.01131 .11525 0 4.5 ]
[.01131 .21578 -24 -4.5 ]
[.01131 .21578 0 4.5 ]
[.01131 .31631 -24 -4.5 ]
[.01131 .31631 0 4.5 ]
[.01131 .41684 -24 -4.5 ]
[.01131 .41684 0 4.5 ]
[.01131 .51737 -24 -4.5 ]
[.01131 .51737 0 4.5 ]
[.01131 .6179 -24 -4.5 ]
[.01131 .6179 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.15079 .01472 m
.15079 .02097 L
s
[(2)] .15079 .00222 0 1 Mshowa
.27778 .01472 m
.27778 .02097 L
s
[(4)] .27778 .00222 0 1 Mshowa
.40476 .01472 m
.40476 .02097 L
s
[(6)] .40476 .00222 0 1 Mshowa
.53175 .01472 m
.53175 .02097 L
s
[(8)] .53175 .00222 0 1 Mshowa
.65873 .01472 m
.65873 .02097 L
s
[(10)] .65873 .00222 0 1 Mshowa
.78571 .01472 m
.78571 .02097 L
s
[(12)] .78571 .00222 0 1 Mshowa
.9127 .01472 m
.9127 .02097 L
s
[(14)] .9127 .00222 0 1 Mshowa
.125 Mabswid
.05556 .01472 m
.05556 .01847 L
s
.0873 .01472 m
.0873 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.18254 .01472 m
.18254 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.24603 .01472 m
.24603 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.34127 .01472 m
.34127 .01847 L
s
.37302 .01472 m
.37302 .01847 L
s
.43651 .01472 m
.43651 .01847 L
s
.46825 .01472 m
.46825 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.56349 .01472 m
.56349 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62698 .01472 m
.62698 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.72222 .01472 m
.72222 .01847 L
s
.75397 .01472 m
.75397 .01847 L
s
.81746 .01472 m
.81746 .01847 L
s
.84921 .01472 m
.84921 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.94444 .01472 m
.94444 .01847 L
s
.97619 .01472 m
.97619 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .11525 m
.03006 .11525 L
s
[(0.01)] .01131 .11525 1 0 Mshowa
.02381 .21578 m
.03006 .21578 L
s
[(0.02)] .01131 .21578 1 0 Mshowa
.02381 .31631 m
.03006 .31631 L
s
[(0.03)] .01131 .31631 1 0 Mshowa
.02381 .41684 m
.03006 .41684 L
s
[(0.04)] .01131 .41684 1 0 Mshowa
.02381 .51737 m
.03006 .51737 L
s
[(0.05)] .01131 .51737 1 0 Mshowa
.02381 .6179 m
.03006 .6179 L
s
[(0.06)] .01131 .6179 1 0 Mshowa
.125 Mabswid
.02381 .03482 m
.02756 .03482 L
s
.02381 .05493 m
.02756 .05493 L
s
.02381 .07503 m
.02756 .07503 L
s
.02381 .09514 m
.02756 .09514 L
s
.02381 .13535 m
.02756 .13535 L
s
.02381 .15546 m
.02756 .15546 L
s
.02381 .17557 m
.02756 .17557 L
s
.02381 .19567 m
.02756 .19567 L
s
.02381 .23588 m
.02756 .23588 L
s
.02381 .25599 m
.02756 .25599 L
s
.02381 .2761 m
.02756 .2761 L
s
.02381 .2962 m
.02756 .2962 L
s
.02381 .33642 m
.02756 .33642 L
s
.02381 .35652 m
.02756 .35652 L
s
.02381 .37663 m
.02756 .37663 L
s
.02381 .39673 m
.02756 .39673 L
s
.02381 .43695 m
.02756 .43695 L
s
.02381 .45705 m
.02756 .45705 L
s
.02381 .47716 m
.02756 .47716 L
s
.02381 .49726 m
.02756 .49726 L
s
.02381 .53748 m
.02756 .53748 L
s
.02381 .55758 m
.02756 .55758 L
s
.02381 .57769 m
.02756 .57769 L
s
.02381 .5978 m
.02756 .5978 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .30171 m
.06244 .44666 L
.08255 .50925 L
.0932 .53658 L
.10458 .56077 L
.11531 .57858 L
.12507 .59053 L
.12977 .59485 L
.13488 .59852 L
.13722 .59985 L
.1397 .60102 L
.14183 .60182 L
.14415 .6025 L
.14546 .6028 L
.14667 .60301 L
.14783 .60316 L
.14907 .60327 L
.15028 .60332 L
.15142 .60332 L
.15245 .60327 L
.15356 .60318 L
.15479 .60304 L
.15613 .60281 L
.15753 .60251 L
.15884 .60217 L
.16133 .60136 L
.16369 .6004 L
.16831 .598 L
.17252 .59524 L
.18199 .58716 L
.19164 .57652 L
.2019 .56291 L
.22032 .5337 L
.25807 .46206 L
.29827 .38097 L
.33696 .30792 L
.3781 .24077 L
.41772 .18775 L
.45583 .14702 L
.49639 .11325 L
.53544 .08844 L
.57693 .06861 L
.61692 .05442 L
.65538 .04424 L
.6963 .03622 L
.7357 .03054 L
.77359 .02649 L
.81393 .0233 L
.85276 .02105 L
.89403 .0193 L
Mistroke
.93379 .01807 L
.97204 .0172 L
.97619 .01712 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/@P10`4000010?ooo`000063aP00002h
Z2iLF0EkL:Cek/c<c6IVIXR8R?GemE>6Rl30`61PH?oo0=:dS6UJA_ola?o[cDQ0B920T=WIfK>c/`00
ogmoOlZcbS9UI@3o08]gI@1T0;:b/X20P000P6@0080004:JYkZPY`0g?0200020P03ooaYOIbmnR800
P8200?l00?l0o`00kUDJRoooc=>e]@00_nOWifm_Kn7QhFEUIINGUnoShgYYJFVe]L3Ph3USHj>SX`00
<`00IP00V@00c00c000c<`0cIP0cV@0cc00co`1V001V<`1VIP1VV@1Vc01Vo`2I002I<`2IIP2IV@2I
c02Io`3<003<<`3<IP3<V@3<c03<o`3o<`3oIP3oV@3oc4000400<d00IT00VD00c400od0c040c<d0c
IT0cVD0cc40cod1V041V<d1VIT1VVD1Vc41Vod2I042I<d2IIT2IVD2Ic42Iod3<043<<d3<IT3<VD3<
c43<od3o043o<d3oIT3oVD3oc43ooh00<h00IX00VH00c800oh0c080c<h0cIX0cVH0cc80coh1V081V
<h1VIX1VVH1Vc81Voh2I082I<h2IIX2IVH2Ic82Ioh3<083<<h3<IX3<VH3<c83<oh3o083o<h3oIX3o
VH3oc83ookl00;l0<kl0I[l0VKl0c;l0oklc0;lc<klcI[lcVKlcc;lcokmV0;mV<kmVI[mVVKmVc;mV
oknI0;nI<knII[nIVKnIc;nIoko<0;o<<ko<I[o<VKo<c;o<okoo0;oo<kooI[ooVKooc;ooool0<ol0
I_l0VOl0c?lc0?lc<olcI_lcVOlcc?lcoomV0?mV<omVI_mVVOmVc?mVoonI0?nI<onII_nIVOnIc?nI
ooo<0?o<<oo<I_o<VOo<c?o<oooo<oooI_ooVG:OolCGociGS667fLc<Xhb<L?m50=WI[TnDcGMgMda<
C71`o`00L000fLC4a>[ZjW1`L:j^[WAdM8b<S:NWYj0Pl?l08@000?l08@000?l08@0003/0104P0003
0@0001d00P4P008170040@<00P4H00@10P040AP0104400030@0001<0000k00030@00024000<10000
70001040004N00040@000Ad000D100000@0200030@0001L000D100000@0M00030@0000<000<10000
4`0003`000<100007@050Ad000@100017P001040004M00050@0000400P000`40000G00030@000080
00<100006P000`4000050A@0000m00030@0001`000@100017P030B000P4N00050@0000400P000`40
000G00030@0000<000<100006@001040004200030@0001<0000n00030@0001`000<100407P000`40
000O00040@000Ad000D100000@0200030@0001L000<1000010000`40000H00070@0000400@0E0000
6`000`40000M00040@000Al00P4N00030@0001l000@100016`030@<000@100015`030@<000@10001
60030@@00P4E00006`000`40000N00818@000`40000M00<17`020Ah000<100000P020AX000<10000
0P020A/000<100000`000`40000C00006`000`40003o00<0000K00030@000?l00`0001D0o`4;0@40
000K00030@0000H000<100001@000`40000500030@0000H000<100001@000`40000600030@0000D0
00<100001P000`40000500030@0000D000<100001P000`40000500030@0000H000<100001@000`40
000600030@0000D000<100001@000`40000600030@0000D000<100001P000`40000500030@0000D0
00<100001P000`40000500030@0000H000<100001@000`40000401`11`0001/000<100007`000`40
000O00030@0001h000<100007`000`40000O00030@0001h000<100005@4:00030@0001H0000K0003
0@000;l02`4h00006`000`40002h00L1@`0001/00P6d00D1BP0001/000<10000[P050Dl0000K0003
0@000:P01P5D00006`000`40002S00D1FP0001/000<10000WP050El0000K00030@0009X0105T0000
6`020IP00`5X00006`000`40002E0081J`0001/000<10000TP030Fd0000K00030@0008l00`5`0000
6`000`40002=0081L`0001/00P6<0081M@0001/000<10000R@020GL0000K00030@0008L00P5i0000
6`000`4000250081N`0001/000<10000P`020Gd0000K0081P`000`40001m00006`000`4000200081
P00001/000<10000O`000`40002000006`000`40001n00030@0008400002008110000`4000030081
0`040@@000<10000O0020H@000001@01000100P000@1000110000`40000300030@0007/000<10000
Q00000050040004020001040004400030@0000<00`5j00030@0008D000001@01000100P000@10001
10000`40000300030@0007P00P68000000D00@000@0800040@000@@000<100000`000`40001g0003
0@0008P000001@01000100P000@100010P030@D000<10000MP000`40002900000P020@X00P450003
0@0000<000<10000M@000`40002:00006`020GD000<10000R`0001/000<10000LP020Hh0000K0003
0@00074000<10000SP0001/000<10000L0000`40002?00006`000`40001_00030@000900000K0081
K`000`40002A00006`000`40001]00030@000980000K00030@0006`000<10000T`0001/000<10000
J`000`40002D00006`000`40001[00030@0009@0000K00030@0006X000<10000U@0001/00P5Z0003
0@0009H0000K00030@0006P000<10000U`0001/000<10000I`000`40002H00006`000`40001V0003
0@0009T0000K00030@0006D000<10000VP0001/00P5U00030@0009/0000K00030@0006@000<10000
V`0001/000<10000H`000`40002L00006`000`40001R00030@0009d00002008110000`4000030081
0`040@@000<10000H@000`40002N000000D00@000@0800040@000@8000<100001@030F4000<10000
WP0000050040004020001040004300030@0000@000<10000H0000`40002O000000D00@000@080004
0@000@@000<100000`000`40001O00030@000:0000001@01000100P000@100011@000`4000020003
0@0005h000<10000X@0000050040004020001040004200040@000@@000<10000G@000`40002R0000
0P020@X00P4400811@000`40001M00030@000:80000K0081G@000`40002S00006`000`40001K0003
0@000:@0000K00030@0005X000<10000Y@0001/000<10000FP000`40002U00006`000`40001I0003
0@000:H0000K0081FP000`40002V00006`000`40001H00030@000:L0000K00030@0005L000<10000
Z00001/000<10000E`000`40002X00006`000`40001F00030@000:T0000K0081E`000`40002Y0000
6`000`40001E00030@000:X0000K00030@0005@000<10000Z`0001/000<10000E0000`40002[0000
6`000`40001C00030@000:`0000K00030@00058000<10000[@0001/00P5C00030@000:d0000K0003
0@00054000<10000[P0001/000<10000D@000`40002^00006`020E4000<10000[`0000800P440003
0@0000<00P4400811@020E0000<10000/00000050040004020001040004200040@000@@00`5?0003
0@000;0000001@01000100P000@100011@000`4000020081C`000`40002a000000D00@000@080004
0@000@<00P4500030@0104h000<10000/@0000050040004020001040004500030@00008000<10040
C@000`40002b000000D00@000@0800040@000@8000@1000110000`400@1=00030@000;8000020081
2P020@@00P4500<1C0000`40002c00006`001040005;00030@000;<0000K00040@000DX000<10000
]00001/000@10001BP000`40002d00006`001040005900030@000;D0000K00050@000040B0000`40
002e00006`020@8000<10000A@000`40002f00006`001@40000104L000<10000]P0001/000D10000
0@1600030@000;L0000K00030@00008000<10000@`000`40002g00006`000`40000200030@000480
00<10000^00001/00P4300030@00048000<10000^00001/000<100000P000`40001100030@000;T0
000K00030@0000<000<10000@0000`40002i00006`000`40000300030@0003l000<10000^P0001/0
00<100000`000`40000o00030@000;X0000K008110000`40000n00030@000;/0000K00030@0000@0
00<10000?@000`40002k00006`000`40000400030@0003`000<10000_00001/000<1000010000`40
000l00030@000;`00002008110000`40000300811@000`40000300030@0000@000<10000>`000`40
002m000000D00@000@0800040@000@@000<100000`000`40000500030@0003X000<10000_@000005
0040004020001@40004000D110030@D000<10000>@000`40002n000000D00@000@0800060@000@01
0P000`40000300030@0000D000<10000>@000`40002n000000D00@000@0800040@000@8000<10040
1@000`40000500030@0003P000<10000_`0000050040004020001040004300811@000`4000060003
0@0003L000<10000_`0000800P4:00811@000`40000300030@0000H000<10000=P000`4000300000
6`020@L000<10000=P000`40003000006`000`40000600030@0003D000<10000`@0001/000<10000
1`000`40000d00030@000<40000K00030@0000L000<10000<`000`40003200006`000`4000070003
0@0003<000<10000`P0001/00P4900030@00034000<10000``0001/000<1000020000`40000a0003
0@000<<0000K00030@0000T000<10000;`000`40003400006`000`40000900030@0002h000<10000
a@0001/000<100002@000`40000^00030@000<D0000K00030@0000X000<10000;0000`4000360000
6`020@/000<10000;0000`40003600006`000`40000:00030@0002/000<10000a`0001/000<10000
2`000`40000Z00030@000<L0000K00030@0000/000<10000:@000`40003800006`000`40000<0003
0@0002P000<10000b00001/00P4=00030@0002L000<10000b@0001/000<1000030000`40000W0003
0@000<T0000K00030@0000d000<100009@000`40003:00006`000`40000=00030@0002D000<10000
bP0000800P4400030@0000<00P4300<11@000`40000=00030@0002@000<10000b`00000500400040
20001040004500030@0000800`4>00030@0002<000<10000b`000005004000402000104000450003
0@00008000<100003P000`40000R00030@000<`000001@01000100P000@100010P030@D000<10000
3`000`40000Q00030@000<`000001@01000100P000@100010P000`40000500030@0000l000<10000
80000`40003=000000D00@000@0800040@000@8000<100001@000`40000@00030@0001l000<10000
c@0000800P4:00810`040@@000<1000040000`40000N00030@000<h0000K00814@000`40000M0003
0@000<l0000K00030@00014000<1000070000`40003?00006`000`40000A00030@0001/000<10000
d00001/000<100004P000`40000I00030@000=40000K00030@00018000<1000060000`40003B0000
6`020A@000<100005`000`40003B00006`000`40000C00030@0001H000<10000d`0001/000<10000
4`000`40000F00030@000=<0000K00030@0001@000<1000050000`40003D00006`000`40000D0003
0@0001@000<10000e00001/00P4F00030@00018000<10000e@0001/000<100005@000`40000A0003
0@000=H0000K00030@0001H000<100003`000`40003G00006`000`40000G00030@0000d000<10000
f00001/000<1000060000`40000;00030@000=T0000K00030@0001T000<1000020020M`0000K0081
6`020@H00P7N00006`000`40000L00L1g`0001/000<10000o`0300006`000`40003o00<000020081
10000`400003008110020@D000<10000o`03000000D00@000@0800040@000@8000@1000110030Ol0
0`0000050040004020001040004200040@000Ol02P0000050040004020001040004200<1o`0;0000
00D00@000@0800040@000@8000<10000o`0;000000D00@000@0800040@000@8000<10000o`0;0000
\
\>"],
  ImageRangeCache->{{{91.5625, 320.938}, {540.062, 398.75}} -> {-8.44855, 
  0.182493, 0.0594398, 0.000375403}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ptotal := NIntegrate[plandau*pgauss\ , {eprime,  .1, 20}]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-118.071 0.119048 -5.4918 533.706 [
[.2619 .36647 -9 -9 ]
[.2619 .36647 9 0 ]
[.5 .36647 -9 -9 ]
[.5 .36647 9 0 ]
[.7381 .36647 -9 -9 ]
[.7381 .36647 9 0 ]
[.97619 .36647 -12 -9 ]
[.97619 .36647 12 0 ]
[.01131 .05875 -36 -4.5 ]
[.01131 .05875 0 4.5 ]
[.01131 .16549 -36 -4.5 ]
[.01131 .16549 0 4.5 ]
[.01131 .27223 -36 -4.5 ]
[.01131 .27223 0 4.5 ]
[.01131 .48571 -36 -4.5 ]
[.01131 .48571 0 4.5 ]
[.01131 .59245 -36 -4.5 ]
[.01131 .59245 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .37897 m
.2619 .38522 L
s
[(994)] .2619 .36647 0 1 Mshowa
.5 .37897 m
.5 .38522 L
s
[(996)] .5 .36647 0 1 Mshowa
.7381 .37897 m
.7381 .38522 L
s
[(998)] .7381 .36647 0 1 Mshowa
.97619 .37897 m
.97619 .38522 L
s
[(1000)] .97619 .36647 0 1 Mshowa
.125 Mabswid
.08333 .37897 m
.08333 .38272 L
s
.14286 .37897 m
.14286 .38272 L
s
.20238 .37897 m
.20238 .38272 L
s
.32143 .37897 m
.32143 .38272 L
s
.38095 .37897 m
.38095 .38272 L
s
.44048 .37897 m
.44048 .38272 L
s
.55952 .37897 m
.55952 .38272 L
s
.61905 .37897 m
.61905 .38272 L
s
.67857 .37897 m
.67857 .38272 L
s
.79762 .37897 m
.79762 .38272 L
s
.85714 .37897 m
.85714 .38272 L
s
.91667 .37897 m
.91667 .38272 L
s
.25 Mabswid
0 .37897 m
1 .37897 L
s
.02381 .05875 m
.03006 .05875 L
s
[(0.0104)] .01131 .05875 1 0 Mshowa
.02381 .16549 m
.03006 .16549 L
s
[(0.0106)] .01131 .16549 1 0 Mshowa
.02381 .27223 m
.03006 .27223 L
s
[(0.0108)] .01131 .27223 1 0 Mshowa
.02381 .48571 m
.03006 .48571 L
s
[(0.0112)] .01131 .48571 1 0 Mshowa
.02381 .59245 m
.03006 .59245 L
s
[(0.0114)] .01131 .59245 1 0 Mshowa
.125 Mabswid
.02381 .08543 m
.02756 .08543 L
s
.02381 .11212 m
.02756 .11212 L
s
.02381 .1388 m
.02756 .1388 L
s
.02381 .19218 m
.02756 .19218 L
s
.02381 .21886 m
.02756 .21886 L
s
.02381 .24555 m
.02756 .24555 L
s
.02381 .29892 m
.02756 .29892 L
s
.02381 .3256 m
.02756 .3256 L
s
.02381 .35229 m
.02756 .35229 L
s
.02381 .40566 m
.02756 .40566 L
s
.02381 .43234 m
.02756 .43234 L
s
.02381 .45903 m
.02756 .45903 L
s
.02381 .5124 m
.02756 .5124 L
s
.02381 .53908 m
.02756 .53908 L
s
.02381 .56577 m
.02756 .56577 L
s
.02381 .03206 m
.02756 .03206 L
s
.02381 .00538 m
.02756 .00538 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .01472 m
.06244 .09072 L
.10458 .16841 L
.14415 .23621 L
.18221 .29648 L
.22272 .35514 L
.26171 .40608 L
.30316 .45411 L
.34309 .49426 L
.3815 .5271 L
.42237 .5557 L
.46172 .57697 L
.48147 .58531 L
.49955 .59156 L
.51896 .59679 L
.52966 .59903 L
.53984 .60072 L
.54943 .60193 L
.55479 .60244 L
.55964 .6028 L
.56419 .60306 L
.56676 .60316 L
.56911 .60323 L
.57011 .60326 L
.57118 .60328 L
.57235 .6033 L
.57345 .60331 L
.57468 .60332 L
.57585 .60332 L
.57689 .60332 L
.57803 .60331 L
.57925 .60329 L
.58037 .60327 L
.58159 .60324 L
.58288 .60321 L
.58505 .60314 L
.58743 .60303 L
.59281 .60271 L
.59781 .60231 L
.60796 .60118 L
.61881 .59951 L
.62906 .59749 L
.64016 .59482 L
.66031 .58869 L
.70123 .5712 L
.74063 .54799 L
.77852 .51986 L
.81886 .48373 L
.85768 .44304 L
.89896 .39356 L
Mistroke
.93872 .33996 L
.97619 .28429 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/@P10`4000010?ooo`000063aP00002h
Z2iLF0EkL:Cek/c<c6IVIXR8R?GemE>6Rl30`61PH?oo0=:dS6UJA_ola?o[cDQ0B920T=WIfK>c/`00
ogmoOlZcbS9UI@3o08]gI@1T0;:b/X20P000P6@0080004:JYkZPY`0g?0200020P03ooaYOIbmnR800
P8200?l00?l0o`00kUDJRoooc=>e]@00_nOWifm_Kn7QhFEUIINGUnoShgYYJFVe]L3Ph3USHj>SX`00
<`00IP00V@00c00c000c<`0cIP0cV@0cc00co`1V001V<`1VIP1VV@1Vc01Vo`2I002I<`2IIP2IV@2I
c02Io`3<003<<`3<IP3<V@3<c03<o`3o<`3oIP3oV@3oc4000400<d00IT00VD00c400od0c040c<d0c
IT0cVD0cc40cod1V041V<d1VIT1VVD1Vc41Vod2I042I<d2IIT2IVD2Ic42Iod3<043<<d3<IT3<VD3<
c43<od3o043o<d3oIT3oVD3oc43ooh00<h00IX00VH00c800oh0c080c<h0cIX0cVH0cc80coh1V081V
<h1VIX1VVH1Vc81Voh2I082I<h2IIX2IVH2Ic82Ioh3<083<<h3<IX3<VH3<c83<oh3o083o<h3oIX3o
VH3oc83ookl00;l0<kl0I[l0VKl0c;l0oklc0;lc<klcI[lcVKlcc;lcokmV0;mV<kmVI[mVVKmVc;mV
oknI0;nI<knII[nIVKnIc;nIoko<0;o<<ko<I[o<VKo<c;o<okoo0;oo<kooI[ooVKooc;ooool0<ol0
I_l0VOl0c?lc0?lc<olcI_lcVOlcc?lcoomV0?mV<omVI_mVVOmVc?mVoonI0?nI<onII_nIVOnIc?nI
ooo<0?o<<oo<I_o<VOo<c?o<oooo<oooI_ooVG:OolCGociGS667fLc<Xhb<L?m50=WI[TnDcGMgMda<
C71`o`00L000fLC4a>[ZjW1`L:j^[WAdM8b<S:NWYj0Pl?l08@000?l08@000?l08@000?l08@000?l0
8@000?l08@000?l08@000?l08@000?l08@000?l08@000?l08@0002L000<10000mP0002L000<10000
mP0002L00P7g00009`000`40003f00009`000`40003f00009`000`40003f00009`020OL0000W0081
m`0002L00`7f00009`000`400@3f00009`001040007e00009`001040007e00009`001@4000010?@0
000W00050@000040m00000800P4400030@0000<00P4300@10`020@D000<100000`000`4000020003
0@000?4000001@01000100P000@1000110001@400001008000<100000P000`40000300810`000`40
003a000000D00@000@0800040@000@@000D100000@0200030@0100@110000`40000300030@000?00
00001@01000100P000@1000110001@400001008000<100400P000`40000300030@0000<000<10000
l00000050040004020001040004400050@0000400P001P4000400@D000<1000010000`40003_0000
00D00@000@0800040@000@800`4300040@000@<00P4500030@0000@000<10000k`0000800P4:0081
1@000`40000200811@000`40000300030@0000D000<10000kP0002L000<100001@000`40003^0000
9`020@L000<10000k@0002L000<100001P000`40003]00009`000`40000700030@000>`0000W0003
0@0000L000<10000k00002L000<1000020000`40003[00009`000`40000800030@000>/0000W0081
2P000`40003Z00009`000`40000900030@000>X0000W00030@0000X000<10000j@0002L000<10000
2`000`40003X00009`000`40000;00030@000>P0000W00030@0000`000<10000i`0002L000<10000
30000`40003W00009`020@h000<10000iP0002L000<100003P000`40003U00009`000`40000>0003
0@000>D0000W00030@0000l000<10000i00002L000<100003`000`40003T00000P020@@000<10000
0`020@<01043008110020@D000<1000040000`40003S000000D00@000@0800040@000@@000D10000
0@0200040@000@8000<100000P020A4000<10000h`0000050040004020001040004400050@000040
0P001040004200030@00008000<100004@000`40003R000000D00@000@0800040@000@@000D10000
0@0200030@0000<11@000`40000B00030@000>4000001@01000100P000@1000110001@4000010080
00@100011`000`40000B00030@000>4000001@01000100P000@100010P030@<000@100010P000`40
000500030@0001<000<10000h00000800P4:00811@000`400002008110030@@000<100004`000`40
003P00009`000`40000D00030@000=l0000W00815@000`40003O00009`000`40000E00030@000=h0
000W00030@0001D000<10000gP0002L000<100005P000`40003M00009`000`40000F00030@000=d0
000W00030@0001L000<10000g00002L000<100005`000`40003L00009`020AT000<10000f`0002L0
00<1000060000`40003K00009`000`40000I00030@000=X0000W00030@0001T000<10000fP0002L0
00<100006P000`40003I00009`000`40000K00030@000=P0000W008170000`40003H00009`000`40
000L00030@000=L0000W00030@0001d000<10000eP0002L000<100007@000`40003F00009`000`40
000N00030@000=D0000W00030@0001l000<10000e00000800P4400030@0000<00P4300@10`020@@0
0P4500030@0001l000<10000e00000050040004020001040004400050@0000400P00104000420003
0@0000800P4Q00030@000=<000001@01000100P000@1000110001@400001008000@100010P000`40
000200030@00024000<10000dP0000050040004020001040004400050@0000400P00104000020@D0
00<100008@000`40003B000000D00@000@0800040@000@@000D100000@0200040@000@8000<10000
0P000`40000R00030@000<@000<100002P0000050040004020001040004200<10`00104000420004
0@000@@000<100008`000`40003200030@0000/0000200812P020@D000<100000P020@@00P450003
0@0002<000<10000`P000`40000;00009`000`40000T00030@000<0000<10000300002L00P4V0003
0@000;h000<100003@0002L000<100009@000`40002m00030@0000h0000W00030@0002H000<10000
_0000`40000>00009`000`40000W00030@000;X000<100003`0002L000<10000:0000`40002h0003
0@000100000W00030@0002P000<10000^0000`40000@00009`020BX000<10000]P000`40000A0000
9`000`40000Z00030@000;@000<100004P0002L000<10000:P000`40002c00030@0001<0000W0003
0@0002/000<10000/P000`40000C00009`000`40000/00030@000;0000<10000500002L000<10000
;@000`4000030@<00`4500030@0002X00`4300<110020B`00`4300<110020BT01043008110020@@0
0P4300009`000`40000]00030@0000<000<100000`000`40000200030@0002d000<100000`001040
004200030@0002`000<100000`001040004200030@0002D000@100010`001040004200040@000@80
00@100010P0002L00P4_00030@00008000<100000`000`400@040Bh000<100000`00104000420003
0@0002`000<100000`001040004200030@0002D000@100010`001040004200040@000@8000@10001
0P0002L000<10000;`000`400@020@<00`401@01000102d00`4300<10P030Bd00`4300<10`020BL0
00D100000@0300040@000@8000@100010P001040004200009`000`40000`00040@000@8000@10001
0P000`400@0/00040@000@8000@100010P000`40000/00040@000@8000@100010P001040004U0003
0@00008000D100000@0200040@000@8000@100010P010@400@0002L000<10000<000104000420004
0@000@<00P4/00040@000@8000@100010P000`40000/00040@000@8000@100010P001040004T0004
0@0000<10`001040004200040@000@8000@100010P0002L000<10000<@020@@00P4500030@0002/0
0P44008110030B`00P44008110020BD000<100000`000`400002008110020@@00P4300009`000`40
000b00030@000:@000<100006P000240n04700009`000`40000;00030@0000`000<1000030000`40
000700030@00008000<100002`000`40000<00030@0000`000<1000030000`40000;00030@0000`0
00<1000030000`40000<00030@0000/000<1000030000`40000900040@000@h000<100002P0002L0
00<10000=0001@40000103X000<10000>0000`40000V00030@0000l000<100002P0002L000<10000
=@000`40002N00030@0001d0000W00030@0003H000<10000W0000`40000N00009`000`40000f0003
0@0009/000<100007`0002L000<10000=`000`40002I00030@000200000W0081>@000`40002H0003
0@000200000W00030@0003T000<10000UP000`40000Q00009`000`40000j00030@0009@000<10000
8P0002L000<10000>`000`40002B00030@0002<0000W00030@0003/000<10000T@000`40000T0000
9`000`40000l00030@0008l000<100009@0002L000<10000?@000`40002>00030@0002D0000W0081
?`000`40002<00030@0002H0000W00030@0003l000<10000RP000`40000W00009`000`4000100003
0@0008P000<10000:00002L000<10000@0000`40002700030@0002T0000W00030@00044000<10000
Q@000`40000Z00009`000`40001200030@0008<000<10000:`0002L00P5400030@00084000<10000
;00002L000<10000A0000`40002000030@0002`0000W00030@0004D000<10000OP000`40000]0000
9`000`40001600030@0007`000<10000;P0002L000<10000A`000`40001j00030@0002l000020081
10000`40000300810`040@80104200@110000`40001800030@0007P000<10000<000000500400040
20001040004400030@0000<000D100000@0700030@0004T000<10000MP000`40000a000000D00@00
0@0800040@000@@000<100000`000`40000200030@0000@00P5;00030@0007@000<10000<P000005
0040004020001040004400030@0000<000<100000`000`40000300030@0004/000<10000LP000`40
000c000000D00@000@0800040@000@@000<100000`000`40000400030@00008000<10000C0000`40
001`00030@0003@000001@01000100P000@100010P030@<00`4300040@000@@000<10000C@000`40
001]0081=`0000800P4:00811@000`40000300030@0000800P4500030@0004h000<10000J`000`40
000g00009`000`40001?00030@0006T000<10000>00002L00P5A0081J0000`40000i00009`000`40
001B00030@0006@000<10000>P0002L000<10000D`000`40001R00030@0003/0000W00030@0005@0
00<10000G`020Ch0000W00030@0005D000<10000G@000`40000n00009`000`40001F0081F`020D40
000W00030@0005P000<10000E`000`40001100009`020EX000<10000E@000`40001200009`000`40
001J0081D`020DD0000W00030@0005`000<10000C`000`40001500009`000`40001M0081C@020DP0
000W00030@0005l000<10000B0020DX0000W00030@0006000P5700030@0004X0000W00030@000680
0P530081C@0002L00P5U0081?`020Dl0000W00030@0006H00P4k0081D@0002L000<10000J0030CH0
0P5C00009`000`40001[0081<@030ED0000W00030@0006d00P4]0081F00000800P4400030@0000<0
0P4300@10P040@@000<100000`000`40001_0081:0030EX000001@01000100P000@1000110000`40
000300030@0000<000<100000`020G80104R0081G@0000050040004020001040004400030@0000<0
00<100001@4400030@0007D0104I00D1G`0000050040004020001040004400030@0000<000@10001
0P000`40000300030@0007T01@4>00H1I00000050040004020001040004400030@0000<000L10000
0@0100D000<10000OP0>0FX000001@01000100P000@100010P030@<00`4400811@000`40003f0000
0P020@X00P4500030@0000<000<100000`000`40000300030@000?H0000W00030@000?H0000W0003
0@000?H0003o0240003o0240003o0240003o0240003o0240003o0240003o0240003o0240003o0240
003o0240003o02400000\
\>"],
  ImageRangeCache->{{{91.5625, 320.938}, {238.5, 97.1875}} -> {986.78, 
  0.0111201, 0.0339523, 7.57337*^-6}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(FindMinimum[\(-ptotal\), {Energy, 992, 1000}, AccuracyGoal -> 10000000]
      \)], "Input"],

Cell[BoxData[
    \({\(-0.0114203562600186359`\), {Energy \[Rule] 996.634706587222751`}}
      \)], "Output"]
}, Open  ]],

Cell[BoxData[""], "Input"],

Cell[BoxData[
    \(expect := NIntegrate[eprime*plandau, {eprime, \(-1\), 20}]\)], "Input"],

Cell[BoxData[
    \(norm := NIntegrate[plandau, {eprime, \(-1\), 20}]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(N[expect/norm]\)], "Input"],

Cell[BoxData[
    \(3.20391436323848166`\)], "Output"]
}, Open  ]]
},
FrontEndVersion->"X 3.0",
ScreenRectangle->{{0, 1280}, {0, 1024}},
WindowSize->{520, 600},
WindowMargins->{{201, Automatic}, {Automatic, 82}},
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"PaperSize"->{612, 792},
"PaperOrientation"->"Portrait",
"Magnification"->1}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1709, 49, 115, 3, 59, "Input"],
Cell[1827, 54, 146, 3, 59, "Input"],

Cell[CellGroupData[{
Cell[1998, 61, 85, 1, 27, "Input"],
Cell[2086, 64, 14452, 465, 186, 5060, 345, "GraphicsData", 
"PostScript", "Graphics"],
Cell[16541, 531, 130, 3, 27, "Output"]
}, Open  ]],
Cell[16686, 537, 73, 1, 27, "Input"],
Cell[16762, 540, 120, 3, 27, "Input"],

Cell[CellGroupData[{
Cell[16907, 547, 67, 1, 27, "Input"],
Cell[16977, 550, 12993, 432, 186, 4633, 324, "GraphicsData", 
"PostScript", "Graphics"],
Cell[29973, 984, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[30140, 992, 90, 1, 27, "Input"],
Cell[30233, 995, 12195, 356, 186, 3574, 245, "GraphicsData", 
"PostScript", "Graphics"],
Cell[42431, 1353, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[42598, 1361, 111, 2, 43, "Input"],
Cell[42712, 1365, 109, 2, 27, "Output"]
}, Open  ]],
Cell[42836, 1370, 26, 0, 27, "Input"],
Cell[42865, 1372, 91, 1, 27, "Input"],
Cell[42959, 1375, 82, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[43066, 1380, 47, 1, 27, "Input"],
Cell[43116, 1383, 54, 1, 27, "Output"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

